/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 61 "src/parse.yy"


#include "decl.h"
#include "expr.h"
#include "func.h"
#include "ispc.h"
#include "module.h"
#include "stmt.h"
#include "sym.h"
#include "type.h"
#include "util.h"

#include <stdio.h>
#include <variant>
#include <llvm/IR/Constants.h>

using namespace ispc;

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

void lCleanUpString(std::string *str);
void lFreeSimpleTemplateID(void *p);
static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl);
static void lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage);

enum class TemplateType { Template, Instantiation, Specialization };
static void lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name);

static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float16", "float", "for", "foreach", "foreach_active", "foreach_tiled",
    "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "invoke_sycl", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", "__attribute__", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float16", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", "__attribute__", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = nullptr, Expr *b = nullptr, Expr *e = nullptr) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 155 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT16_CONSTANT = 15,    /* TOKEN_FLOAT16_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 16,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 17,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 18,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_STRING_SYCL_LITERAL = 19, /* TOKEN_STRING_SYCL_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 20,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 21,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 22,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 23,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 24,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_TEMPLATE_NAME = 25,       /* TOKEN_TEMPLATE_NAME  */
  YYSYMBOL_TOKEN_TEMPLATE = 26,            /* TOKEN_TEMPLATE  */
  YYSYMBOL_TOKEN_TYPENAME = 27,            /* TOKEN_TYPENAME  */
  YYSYMBOL_TOKEN_PTR_OP = 28,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 29,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 30,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 31,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 32,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 33,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 34,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 35,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 36,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 37,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 38,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 39,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 40,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 41,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 42,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 43,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 44,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 45,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 46,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 47,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 48,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 49,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 50,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 51,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 52,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_ALLOCA = 53,              /* TOKEN_ALLOCA  */
  YYSYMBOL_TOKEN_INTRINSIC_CALL = 54,      /* TOKEN_INTRINSIC_CALL  */
  YYSYMBOL_TOKEN_EXTERN = 55,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 56,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 57,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 58,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 59,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 60,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_REGCALL = 61,             /* TOKEN_REGCALL  */
  YYSYMBOL_TOKEN_TASK = 62,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 63,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 64,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 65,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 66,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 67,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 68,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_INT = 69,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 70,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 71,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT16 = 72,             /* TOKEN_FLOAT16  */
  YYSYMBOL_TOKEN_FLOAT = 73,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 74,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 75,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 76,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 77,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 78,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 79,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 80,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 81,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 82,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 83,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 84,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 85,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 86,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 87,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 88,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 89,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 90,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 91,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 92,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 93,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 94,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 95,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 96,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 97,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 98,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 99,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 100,     /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 101,          /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 102,                /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 103,               /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 104,           /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 105,              /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 106,             /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 107,                /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 108,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 109,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 110,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 111,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 112,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 113,             /* TOKEN_ASSERT  */
  YYSYMBOL_TOKEN_INVOKE_SYCL = 114,        /* TOKEN_INVOKE_SYCL  */
  YYSYMBOL_TOKEN_ATTRIBUTE = 115,          /* TOKEN_ATTRIBUTE  */
  YYSYMBOL_116_ = 116,                     /* '('  */
  YYSYMBOL_117_ = 117,                     /* ')'  */
  YYSYMBOL_118_ = 118,                     /* '['  */
  YYSYMBOL_119_ = 119,                     /* ']'  */
  YYSYMBOL_120_ = 120,                     /* ','  */
  YYSYMBOL_121_ = 121,                     /* '<'  */
  YYSYMBOL_122_ = 122,                     /* '>'  */
  YYSYMBOL_123_ = 123,                     /* '.'  */
  YYSYMBOL_124_ = 124,                     /* '&'  */
  YYSYMBOL_125_ = 125,                     /* '*'  */
  YYSYMBOL_126_ = 126,                     /* '+'  */
  YYSYMBOL_127_ = 127,                     /* '-'  */
  YYSYMBOL_128_ = 128,                     /* '~'  */
  YYSYMBOL_129_ = 129,                     /* '!'  */
  YYSYMBOL_130_ = 130,                     /* '/'  */
  YYSYMBOL_131_ = 131,                     /* '%'  */
  YYSYMBOL_132_ = 132,                     /* '^'  */
  YYSYMBOL_133_ = 133,                     /* '|'  */
  YYSYMBOL_134_ = 134,                     /* '?'  */
  YYSYMBOL_135_ = 135,                     /* ':'  */
  YYSYMBOL_136_ = 136,                     /* '='  */
  YYSYMBOL_137_ = 137,                     /* ';'  */
  YYSYMBOL_138_ = 138,                     /* '{'  */
  YYSYMBOL_139_ = 139,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 140,                 /* $accept  */
  YYSYMBOL_string_constant = 141,          /* string_constant  */
  YYSYMBOL_primary_expression = 142,       /* primary_expression  */
  YYSYMBOL_launch_expression = 143,        /* launch_expression  */
  YYSYMBOL_invoke_sycl_expression = 144,   /* invoke_sycl_expression  */
  YYSYMBOL_postfix_expression = 145,       /* postfix_expression  */
  YYSYMBOL_intrinsic_name = 146,           /* intrinsic_name  */
  YYSYMBOL_intrincall_expression = 147,    /* intrincall_expression  */
  YYSYMBOL_funcall_expression = 148,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 149, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 150,         /* unary_expression  */
  YYSYMBOL_cast_expression = 151,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 152, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 153,      /* additive_expression  */
  YYSYMBOL_shift_expression = 154,         /* shift_expression  */
  YYSYMBOL_relational_expression = 155,    /* relational_expression  */
  YYSYMBOL_equality_expression = 156,      /* equality_expression  */
  YYSYMBOL_and_expression = 157,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 158,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 159,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 160,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 161,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 162,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 163,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 164, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 165,           /* new_expression  */
  YYSYMBOL_assignment_expression = 166,    /* assignment_expression  */
  YYSYMBOL_expression = 167,               /* expression  */
  YYSYMBOL_constant_expression = 168,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 169,    /* declaration_statement  */
  YYSYMBOL_declaration = 170,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 171,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 172,            /* declspec_item  */
  YYSYMBOL_declspec_list = 173,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 174,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 175,   /* declaration_specifiers  */
  YYSYMBOL_attribute_specifier = 176,      /* attribute_specifier  */
  YYSYMBOL_attribute_list = 177,           /* attribute_list  */
  YYSYMBOL_attribute = 178,                /* attribute  */
  YYSYMBOL_attribute_argument = 179,       /* attribute_argument  */
  YYSYMBOL_init_declarator_list = 180,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 181,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 182,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 183,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 184,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 185, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 186,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 187,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 188, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 189, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 190,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 191,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 192,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 193, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 194,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 195,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 196,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 197,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 198,          /* enumerator_list  */
  YYSYMBOL_enumerator = 199,               /* enumerator  */
  YYSYMBOL_type_qualifier = 200,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 201,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 202,               /* declarator  */
  YYSYMBOL_int_constant = 203,             /* int_constant  */
  YYSYMBOL_direct_declarator = 204,        /* direct_declarator  */
  YYSYMBOL_pointer = 205,                  /* pointer  */
  YYSYMBOL_reference = 206,                /* reference  */
  YYSYMBOL_parameter_type_list = 207,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 208,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 209,    /* parameter_declaration  */
  YYSYMBOL_type_name = 210,                /* type_name  */
  YYSYMBOL_abstract_declarator = 211,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 212, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 213,              /* initializer  */
  YYSYMBOL_initializer_list = 214,         /* initializer_list  */
  YYSYMBOL_pragma = 215,                   /* pragma  */
  YYSYMBOL_attributed_statement = 216,     /* attributed_statement  */
  YYSYMBOL_statement = 217,                /* statement  */
  YYSYMBOL_labeled_statement = 218,        /* labeled_statement  */
  YYSYMBOL_start_scope = 219,              /* start_scope  */
  YYSYMBOL_end_scope = 220,                /* end_scope  */
  YYSYMBOL_compound_statement = 221,       /* compound_statement  */
  YYSYMBOL_statement_list = 222,           /* statement_list  */
  YYSYMBOL_expression_statement = 223,     /* expression_statement  */
  YYSYMBOL_selection_statement = 224,      /* selection_statement  */
  YYSYMBOL_for_test = 225,                 /* for_test  */
  YYSYMBOL_for_init_statement = 226,       /* for_init_statement  */
  YYSYMBOL_for_scope = 227,                /* for_scope  */
  YYSYMBOL_cfor_scope = 228,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 229,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 230,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 231,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 232,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 233, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 234,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 235, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 236,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 237,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 238, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 239,      /* iteration_statement  */
  YYSYMBOL_240_1 = 240,                    /* $@1  */
  YYSYMBOL_241_2 = 241,                    /* $@2  */
  YYSYMBOL_242_3 = 242,                    /* $@3  */
  YYSYMBOL_243_4 = 243,                    /* $@4  */
  YYSYMBOL_goto_identifier = 244,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 245,           /* jump_statement  */
  YYSYMBOL_sync_statement = 246,           /* sync_statement  */
  YYSYMBOL_delete_statement = 247,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 248,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 249,          /* print_statement  */
  YYSYMBOL_assert_statement = 250,         /* assert_statement  */
  YYSYMBOL_translation_unit = 251,         /* translation_unit  */
  YYSYMBOL_external_declaration = 252,     /* external_declaration  */
  YYSYMBOL_function_definition = 253,      /* function_definition  */
  YYSYMBOL_254_5 = 254,                    /* $@5  */
  YYSYMBOL_template_type_parameter = 255,  /* template_type_parameter  */
  YYSYMBOL_int_constant_type = 256,        /* int_constant_type  */
  YYSYMBOL_template_int_constant_type = 257, /* template_int_constant_type  */
  YYSYMBOL_template_int_parameter = 258,   /* template_int_parameter  */
  YYSYMBOL_template_enum_parameter = 259,  /* template_enum_parameter  */
  YYSYMBOL_template_parameter = 260,       /* template_parameter  */
  YYSYMBOL_template_parameter_list = 261,  /* template_parameter_list  */
  YYSYMBOL_template_head = 262,            /* template_head  */
  YYSYMBOL_template_declaration = 263,     /* template_declaration  */
  YYSYMBOL_264_6 = 264,                    /* $@6  */
  YYSYMBOL_template_function_declaration_or_definition = 265, /* template_function_declaration_or_definition  */
  YYSYMBOL_template_argument = 266,        /* template_argument  */
  YYSYMBOL_template_argument_list = 267,   /* template_argument_list  */
  YYSYMBOL_template_identifier = 268,      /* template_identifier  */
  YYSYMBOL_simple_template_id = 269,       /* simple_template_id  */
  YYSYMBOL_template_function_instantiation = 270, /* template_function_instantiation  */
  YYSYMBOL_template_function_specialization_declaration = 271, /* template_function_specialization_declaration  */
  YYSYMBOL_template_function_specialization = 272 /* template_function_specialization  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  98
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4552

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  140
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  133
/* YYNRULES -- Number of rules.  */
#define YYNRULES  433
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  797

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   370


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   129,     2,     2,     2,   131,   124,     2,
     116,   117,   125,   126,   120,   127,   123,   130,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   135,   137,
     121,   136,   122,   134,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   118,     2,   119,   132,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   138,   133,   139,   128,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   300,   300,   305,   318,   338,   342,   346,   350,   354,
     358,   362,   366,   370,   379,   384,   389,   392,   395,   400,
     401,   405,   411,   418,   424,   431,   437,   443,   449,   456,
     461,   466,   471,   478,   484,   490,   496,   505,   509,   513,
     518,   519,   521,   523,   524,   531,   536,   541,   548,   553,
     558,   560,   565,   572,   585,   601,   602,   604,   606,   608,
     630,   652,   662,   663,   677,   678,   679,   680,   682,   684,
     686,   688,   690,   692,   694,   696,   698,   700,   707,   708,
     715,   716,   718,   720,   725,   726,   728,   733,   734,   736,
     741,   742,   744,   746,   748,   753,   754,   756,   761,   762,
     767,   768,   773,   774,   779,   780,   785,   786,   791,   792,
     797,   798,   799,   803,   804,   815,   826,   850,   851,   855,
     859,   866,   867,   869,   871,   873,   875,   877,   879,   881,
     883,   885,   887,   892,   893,   898,   902,   928,   932,   942,
     947,   958,   965,   977,   985,   989,  1003,  1012,  1025,  1031,
    1042,  1046,  1052,  1065,  1086,  1090,  1097,  1107,  1120,  1127,
    1135,  1146,  1153,  1165,  1169,  1179,  1186,  1200,  1201,  1210,
    1211,  1212,  1213,  1214,  1218,  1219,  1225,  1226,  1230,  1241,
    1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1268,  1272,  1281,  1286,  1294,  1318,  1319,
    1341,  1357,  1365,  1382,  1386,  1393,  1407,  1412,  1413,  1414,
    1415,  1501,  1508,  1522,  1530,  1538,  1544,  1553,  1559,  1568,
    1593,  1603,  1617,  1623,  1651,  1652,  1653,  1654,  1655,  1656,
    1657,  1658,  1659,  1660,  1661,  1662,  1666,  1670,  1677,  1689,
    1701,  1705,  1706,  1707,  1708,  1712,  1721,  1728,  1732,  1763,
    1774,  1778,  1793,  1803,  1811,  1815,  1821,  1827,  1838,  1846,
    1850,  1857,  1866,  1874,  1878,  1887,  1894,  1911,  1912,  1924,
    1928,  1929,  1939,  1943,  1956,  1958,  1964,  1993,  2004,  2035,
    2037,  2047,  2057,  2075,  2076,  2077,  2081,  2083,  2097,  2104,
    2114,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,
    2127,  2128,  2129,  2130,  2138,  2144,  2162,  2167,  2171,  2175,
    2176,  2180,  2186,  2199,  2200,  2204,  2206,  2208,  2210,  2212,
    2217,  2219,  2224,  2225,  2229,  2233,  2237,  2241,  2245,  2253,
    2257,  2265,  2269,  2273,  2277,  2284,  2288,  2295,  2300,  2314,
    2318,  2326,  2328,  2330,  2332,  2334,  2338,  2342,  2346,  2351,
    2350,  2386,  2385,  2422,  2421,  2433,  2431,  2455,  2463,  2469,
    2471,  2473,  2475,  2480,  2485,  2492,  2499,  2505,  2514,  2523,
    2524,  2525,  2529,  2530,  2531,  2532,  2533,  2534,  2535,  2540,
    2546,  2551,  2550,  2588,  2593,  2603,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2615,  2616,  2620,  2625,  2635,  2648,
    2654,  2660,  2669,  2677,  2692,  2700,  2699,  2726,  2733,  2749,
    2756,  2760,  2764,  2768,  2772,  2776,  2780,  2784,  2788,  2791,
    2795,  2816,  2825,  2836,  2844,  2856,  2873,  2899,  2920,  2930,
    2952,  2966,  2976,  2985
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT16_CONSTANT",
  "TOKEN_FLOAT_CONSTANT", "TOKEN_DOUBLE_CONSTANT",
  "TOKEN_STRING_C_LITERAL", "TOKEN_STRING_SYCL_LITERAL",
  "TOKEN_IDENTIFIER", "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME",
  "TOKEN_PRAGMA", "TOKEN_NULL", "TOKEN_TEMPLATE_NAME", "TOKEN_TEMPLATE",
  "TOKEN_TYPENAME", "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP",
  "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP",
  "TOKEN_EQ_OP", "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP",
  "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN",
  "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN",
  "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN",
  "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE",
  "TOKEN_IN", "TOKEN_ALLOCA", "TOKEN_INTRINSIC_CALL", "TOKEN_EXTERN",
  "TOKEN_EXPORT", "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE",
  "TOKEN_VECTORCALL", "TOKEN_REGCALL", "TOKEN_TASK", "TOKEN_DECLSPEC",
  "TOKEN_UNIFORM", "TOKEN_VARYING", "TOKEN_TYPEDEF", "TOKEN_SOA",
  "TOKEN_UNMASKED", "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED",
  "TOKEN_FLOAT16", "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8",
  "TOKEN_INT16", "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL",
  "TOKEN_UINT8", "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64",
  "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "TOKEN_INVOKE_SYCL",
  "TOKEN_ATTRIBUTE", "'('", "')'", "'['", "']'", "','", "'<'", "'>'",
  "'.'", "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'^'",
  "'|'", "'?'", "':'", "'='", "';'", "'{'", "'}'", "$accept",
  "string_constant", "primary_expression", "launch_expression",
  "invoke_sycl_expression", "postfix_expression", "intrinsic_name",
  "intrincall_expression", "funcall_expression",
  "argument_expression_list", "unary_expression", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "and_expression",
  "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "attribute_specifier", "attribute_list",
  "attribute", "attribute_argument", "init_declarator_list",
  "init_declarator", "storage_class_specifier", "type_specifier",
  "type_specifier_list", "atomic_var_type_specifier",
  "short_vec_specifier", "struct_or_union_name",
  "struct_or_union_and_name", "struct_or_union_specifier",
  "struct_or_union", "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5",
  "template_type_parameter", "int_constant_type",
  "template_int_constant_type", "template_int_parameter",
  "template_enum_parameter", "template_parameter",
  "template_parameter_list", "template_head", "template_declaration",
  "$@6", "template_function_declaration_or_definition",
  "template_argument", "template_argument_list", "template_identifier",
  "simple_template_id", "template_function_instantiation",
  "template_function_specialization_declaration",
  "template_function_specialization", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-387)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-382)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1100,  -101,  -387,  4236,    48,   -92,  -387,  -387,  -387,  -387,
    -387,  -387,   -26,  -387,  -387,  -387,   -24,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,    13,  -387,   -10,  -387,  -387,  4401,
    4401,    93,  4401,  4401,  4303,  -387,   -19,  -387,    39,  -387,
    4401,  1014,  -387,  -387,  -387,   222,  -387,  -387,   229,  -387,
    -387,   359,  -387,   288,   127,    18,    56,   717,   161,   302,
    -387,   199,    85,   117,  -387,  -387,  -387,  -387,    12,  -387,
     983,  -387,   -90,  -387,   198,   322,    50,    50,  -387,  -387,
     428,  -387,  3673,  -387,  -387,  3755,  -387,  -387,  -387,  -387,
    4401,  -387,   109,   897,  -387,  -387,  -387,  -387,  -387,   238,
     243,  1034,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,
    -387,  4401,  -387,  -387,   247,  -387,  -387,  -387,   308,  -387,
     160,   233,  4401,  4401,  -387,   -89,  -387,  -387,   -78,  -387,
    -387,  -387,  -387,   186,   178,   -47,  -387,   199,   353,   264,
    -387,   983,  -387,    12,  -387,  1242,   257,  3913,  2097,   322,
     322,   278,   284,  -387,  4369,  -387,  3786,  -387,    12,  4466,
    -387,  3827,    12,  -387,   282,  -387,  -387,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,   325,  -387,  -387,  3301,
    3301,  3370,  -387,  3094,   306,  -387,   389,   416,   367,  -387,
    -387,  3439,   348,   375,   402,   410,   897,   338,  -387,  -387,
    -387,  -387,  -387,   527,   415,   423,  1504,   442,   897,  -387,
     453,   447,   457,   479,   490,  1692,  3301,  3301,  3439,  3439,
    3439,  3439,  -387,  -387,  -387,  -387,   167,   491,  -387,  -387,
     469,  -387,   -14,   285,   356,    51,   504,   485,   486,   478,
     582,   -13,  -387,  1267,  -387,  -387,   -38,  -387,  -387,    93,
     897,  -387,  -387,  -387,  -387,   619,  -387,  -387,   514,   524,
     529,   530,   531,   535,  -387,   518,  -387,  -387,  -387,  -387,
    -387,  -387,   539,  -387,   522,  -387,   127,   523,   854,  -387,
    4259,  3999,   521,   525,   717,   526,  -387,   161,  -387,  3439,
      -1,  -387,   -41,   546,    84,  -387,  -387,  -387,  -387,  -387,
     575,  -387,   389,   416,  1242,  -387,  -387,  -387,    91,  -387,
     104,   548,   547,  -387,   552,  -387,  -387,  -387,   601,  -387,
    -387,   567,  -387,  -387,  -387,   -29,  -387,  -387,  -387,  -387,
    -387,  -387,  1959,  -387,  -387,  1692,  -387,   -27,  3094,  -387,
    -387,   897,   602,   897,  3094,  3094,  3094,   572,  3094,  2351,
     177,  -387,   599,  -387,  -387,  -387,    27,  3094,   644,  3094,
    -387,   719,   719,  2159,   624,   107,    74,   625,  -387,  -387,
    -387,  -387,  -387,  -387,   145,  -387,  -387,  1821,  2028,   190,
    2277,  3094,  3094,  3094,  3094,  3094,  3094,  3094,  3094,  3094,
    3094,  3094,  3439,  3439,  3439,  3439,  3439,  3439,  3439,  3439,
    3439,  3439,  3439,  3439,  3439,  3439,  3439,  3439,  3439,  3439,
    3094,   717,   717,   335,   717,  -387,  3094,  -387,  -387,  -387,
    -387,  -387,  1369,  1369,   729,   729,   730,   731,   897,  1890,
     717,   636,   302,  -387,  -387,  -387,  -387,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,  -387,   345,   114,   616,
     637,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,     9,
    -387,   261,   638,   353,  -387,   -37,  -387,  -387,  3514,  3163,
     633,    44,    44,  -387,   388,  -387,  4401,  -387,  -387,   648,
     649,    12,  -387,   643,  -387,   655,   758,   897,  -387,   132,
     139,   157,   660,   459,   268,  2404,  -387,  -387,   159,   661,
     169,  -387,     6,    33,   662,   155,  -387,  -387,  3600,   430,
     430,  -387,  3439,  -387,  -387,  -387,   667,  -387,   174,  -387,
     666,   466,  -387,  -387,  -387,  -387,   182,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,
    -387,   -14,   -14,   285,   285,   356,   356,   356,   356,    51,
      51,   504,   485,   486,   478,   582,   -58,  -387,  -387,  1242,
    3094,  -387,  -387,  -387,  -387,  1557,  1557,  -387,   659,  -387,
     184,   272,  -387,   687,  -387,   753,  -387,   689,  -387,   277,
    -387,  4085,  -387,  4259,  -387,   673,  -387,   713,  -387,   838,
     760,  -387,  -387,  -387,  1189,  -387,   755,  -387,   761,   762,
    -387,   769,  1242,   388,   388,  4171,  3232,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,   897,   897,   897,  3094,  3684,
    3094,  2473,  -387,   279,   897,  3094,   897,  -387,   743,  3094,
    3094,  -387,  -387,  3094,  -387,  -387,  -387,  3094,  -387,  -387,
    -387,  3439,   287,   471,  -387,    43,  2542,  2611,  2224,  -387,
     729,  -387,  -387,  3094,  -387,  -387,   303,  -387,   772,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,  -387,
     773,  -387,   774,   799,  -387,  -387,   304,  3094,  2351,   346,
     474,   770,   312,  -387,   802,   327,  -387,  -387,   354,   360,
     361,  -387,  -387,  -387,  1242,  -387,  -387,   897,   365,   897,
     380,  -387,  -387,  -387,  -387,   798,  3094,   897,  -387,   897,
     897,   381,  -387,  -387,  -387,  -387,   897,   771,   790,   465,
    2680,  2351,  3094,  -387,   788,   897,   778,   779,   787,  -387,
    -387,   897,  -387,   897,  3094,  -387,  -387,  -387,  -387,  -387,
    -387,  -387,  3923,  2749,  -387,   382,   492,   792,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,  -387,   897,  3094,   515,   803,
     407,  -387,  2818,  2351,  -387,   809,  2887,  -387,   810,  -387,
     411,   534,  2351,  -387,   417,  -387,  -387,  2956,   538,  -387,
    -387,   421,  3025,  -387,  -387,   436,  -387
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   175,     0,   170,   229,   173,   230,   231,   232,
     233,   227,     0,   225,   226,   169,     0,   228,   186,   234,
     235,   188,   189,   190,   182,   184,   191,   224,   180,   181,
     183,   185,   187,   192,     0,   203,     0,   380,   379,   148,
     146,     0,   156,   144,   150,   174,   198,   176,     0,   177,
     154,     0,   369,   372,   405,     0,   373,   375,     0,   374,
     371,   170,   229,     0,     0,   171,   172,     0,     0,     0,
     214,     0,   219,     0,   149,   147,   245,   246,     0,   258,
     254,   137,     0,   165,   167,   240,     0,     0,   157,   145,
       0,   153,     0,   195,   196,     0,   197,   155,     1,   370,
       0,   407,   307,     0,   408,   432,   433,   171,   172,     0,
       0,     0,   387,   385,   386,   388,   393,   389,   390,   391,
     392,     0,   399,   395,     0,   400,   401,   402,     0,   423,
     425,     0,     0,     0,   178,     0,   140,   141,     0,   241,
     242,   243,   244,     0,   222,     0,   220,     0,     0,     0,
     236,   255,   256,     0,   138,     0,     0,     0,     0,   238,
     239,     0,     0,   202,   208,   209,     0,   204,     0,     0,
     201,     0,     0,   309,     0,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,     4,   288,    18,     0,
       0,     0,   110,     0,     0,    52,   225,   226,   228,    16,
      17,     0,     0,     0,     0,     0,     0,     0,   326,   327,
     339,   329,   324,     0,     0,     0,     0,     0,     0,   325,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   313,    40,    43,    66,    55,     0,    65,    64,
      78,    80,    84,    87,    90,    95,    98,   100,   102,   104,
     106,   108,   117,     0,   121,   133,     0,   297,   136,     0,
       0,   311,   290,   291,   292,     0,   293,   294,     0,     0,
       0,     0,     0,     0,   295,     0,   296,   300,   301,   302,
     298,   299,     0,   398,   383,   394,     0,   396,     0,   404,
       0,     0,     0,     0,     0,     0,   143,     0,   139,     0,
       0,   215,     0,   161,     0,   159,   247,   237,   257,   166,
     167,     4,     0,     0,     0,   283,   168,   382,     0,   252,
     266,     0,   259,   260,     0,   249,    78,   135,     0,   152,
     151,     0,   207,   199,   205,     0,   211,   213,   210,   200,
     406,   303,     0,    67,    68,     0,    75,     0,     0,   111,
     112,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   357,     0,   359,   360,   361,     0,     0,     0,     0,
     363,     0,     0,     0,     0,     0,   267,     0,    69,    70,
      71,    72,    73,    74,     0,    50,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,     0,   113,     0,   314,   289,   308,
     312,   310,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   403,   410,   411,   412,   413,   414,   415,
     416,   417,   420,   418,   419,   409,   421,     0,     0,     0,
       0,   376,   377,   179,   378,   142,   223,   217,   221,     0,
     216,     0,     0,     0,   286,     0,   253,   262,     0,     0,
     263,   269,   272,   265,   270,   251,     0,   250,   248,     0,
       0,     0,   206,     0,   364,     0,     0,     0,   306,     0,
       0,     0,     0,     0,     0,     0,   358,   362,     0,     0,
       0,     2,     0,     0,     0,     0,    20,    19,     0,   269,
     272,   268,     0,    47,    48,    49,     0,    56,     0,    62,
       0,     0,    44,    45,    46,    53,     0,   123,   124,   125,
     126,   127,   128,   129,   130,   132,   131,   122,    81,    82,
      83,    85,    86,    88,    89,    93,    94,    91,    92,    96,
      97,    99,   101,   103,   105,   107,     0,   114,   115,     0,
       0,   116,   134,   323,   322,     0,     0,   328,     0,   337,
       0,     0,   330,     0,   340,     0,   304,     0,    59,     0,
     384,     0,   397,     0,   424,     0,   427,     0,   218,   164,
       0,   163,   158,   160,     0,   284,     0,   279,     0,     0,
     275,     0,     0,   271,   273,     0,     0,   261,   194,   193,
     212,    76,    77,   365,   305,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     3,     0,     0,
       0,    39,    37,     0,    79,    58,    57,     0,    42,    41,
      54,     0,     0,     0,   320,     0,     0,     0,     0,   349,
       0,   351,   353,     0,    61,    60,     0,   430,     0,   422,
     428,   426,   162,   285,   287,   280,   274,   276,   264,   281,
       0,   277,     0,   315,   319,   341,     0,     0,     0,     0,
       0,     0,     0,    21,   317,     0,   342,   366,     0,     0,
       0,    63,   109,   119,     0,   120,   321,     0,     0,     0,
       0,   331,   332,   333,   334,     0,     0,     0,   338,     0,
       0,     0,   431,   429,   282,   278,     0,     0,     0,     0,
       0,     0,     0,    34,     0,     0,     0,     0,     0,    38,
     345,     0,   347,     0,     0,   336,   350,   352,   354,   355,
     316,   343,     0,     0,    24,     0,     0,     0,    33,   318,
     344,   367,   368,   346,   348,   335,     0,     0,     0,     0,
       0,    23,     0,     0,   356,     0,     0,    36,     0,    26,
       0,     0,     0,    28,     0,    35,    25,     0,     0,    27,
      30,     0,     0,    29,    32,     0,    31
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -387,  -317,  -387,  -387,  -387,  -202,  -387,  -387,  -387,  -374,
     -86,  -142,   191,   192,   -72,   188,   528,   517,   532,   571,
     520,  -387,  -144,  -387,   688,  -387,  -155,  -167,  -199,   171,
      17,  -242,   645,  -387,  -387,     1,  -387,  -387,   467,  -387,
    -387,   791,  -387,   -39,  -387,  -387,  -387,  -387,  -387,  -387,
    -387,   850,     8,  -154,  -387,   507,   981,  -387,   869,  -287,
     -57,  -387,   -33,   -81,   -66,   -73,  -302,  -145,  -387,   533,
     672,  -296,  -386,  -149,   449,  -387,  -184,  -387,  -387,  -387,
    -387,     5,   669,   181,  -387,   451,   595,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,  -387,   369,   596,  -387,  -387,  -387,
    -387,  -387,  -387,  -387,   817,  -387,  -387,  -387,  -387,  -387,
    -387,  -387,   982,  -387,  -387,  -387,   921,  -387,  -387,  -387,
     749,  -387,  -387,  -387,  -387,  -387,   445,  -387,  -387,   -61,
    -387,  -387,  -387
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   512,   233,   234,   235,   236,   237,   238,   239,   528,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   455,   254,   255,   256,   328,   257,
     258,    39,   137,   138,    40,   259,    42,   304,   305,   600,
      82,    83,    43,    44,   135,    45,   165,    96,    46,    47,
      48,   166,   167,   168,   335,   336,   144,    49,   145,   146,
      50,   151,   149,   143,    85,    86,    87,   608,   322,   323,
     377,   609,   484,   474,   475,   260,   261,   262,   263,   103,
     431,   264,   265,   266,   267,   656,   575,   268,   269,   270,
     271,   578,   272,   583,   716,   579,   580,   273,   585,   274,
     717,   719,   720,   766,   275,   276,   277,   278,   279,   280,
     281,    51,    52,    53,   156,   122,   123,   124,   125,   126,
     127,   128,    54,    55,   100,    56,   456,   457,   130,   282,
      57,    58,    59
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     315,    41,   352,   131,    64,   360,   316,   152,    84,   162,
     332,   424,   321,   468,   327,   338,   536,    38,   482,    70,
     159,   160,   357,   150,   483,   419,   347,   637,   134,    70,
     153,   294,    76,    70,   368,   169,    60,    77,   169,   296,
      74,    75,   297,    88,    89,    91,    67,   154,   424,   366,
     295,    97,    41,   164,   637,   513,   164,   327,   375,    93,
     104,    94,   426,   106,    76,   589,    65,    66,    38,    77,
      76,   376,   326,   300,   520,    77,   428,   651,   308,   469,
     521,   430,   426,   604,   409,   410,   380,   381,   382,   383,
      68,   491,   301,   426,   307,   613,   614,    69,   470,   427,
     466,   172,   605,   343,   344,   346,    73,   169,   492,   169,
     494,   402,   169,    76,   169,   326,   403,   404,    77,    92,
     310,   420,   286,   638,    76,   164,   639,   164,    78,    77,
     164,   633,   164,   613,   614,   337,    79,    80,   467,   340,
     378,   379,   326,   326,   326,   326,   460,   426,   598,   292,
     293,    71,   129,   640,   599,   327,   132,   504,   320,   315,
     478,   317,   479,   426,   507,   523,    78,   524,   169,   498,
     525,   515,   411,   412,   334,   375,   482,    95,   375,   334,
     706,   136,   468,   384,   385,   386,   164,   499,   500,   501,
     518,   376,   479,   495,   133,   384,   385,   386,    79,    80,
     508,   472,   510,   503,   473,   384,   385,   386,   476,    78,
     532,   477,   533,   326,   425,   534,   520,    79,    80,    70,
     478,   531,   479,   147,   517,   441,   310,   426,    79,    80,
      81,   595,   529,   148,   477,   529,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   481,   173,   625,
     490,   425,   426,   566,   586,   463,   626,   692,   283,   426,
     548,   549,   550,   284,   139,   698,   140,   287,   141,   700,
     142,   572,   642,   388,   627,   643,   634,   426,   389,   426,
     611,   290,   511,   387,   529,   388,   636,   480,   169,   426,
     389,   646,   320,   505,   647,   388,   384,   385,   386,   650,
     389,   659,   647,   519,   660,   139,   164,   140,   298,   141,
     109,   142,   430,   624,   299,   110,   326,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   326,   326,   155,   327,  -381,   555,   556,   557,
     558,   175,   176,   177,   178,   179,   180,   181,   182,   291,
     529,   424,   111,   183,   184,   185,   755,   112,   311,   101,
     102,   592,   188,   113,   114,   115,   105,   102,   116,   117,
     118,   119,   120,   303,   384,   385,   386,   107,   108,   770,
     644,   306,   567,   568,   631,   571,   388,   407,   408,   661,
     601,   389,   660,   326,   665,   102,   693,   647,   780,   647,
     329,   590,   784,   653,   703,   481,   330,   704,   655,   655,
     121,   405,   406,   791,   315,   159,   160,   682,   795,   341,
     722,   727,   348,   477,   426,   199,   200,   689,   288,   734,
     289,   139,   647,   140,   207,   141,   326,   142,   157,   349,
     158,   683,   684,   685,   736,   519,   668,   426,   161,   315,
     694,   569,   696,   570,   342,   674,   358,   315,   337,   359,
    -357,   686,   730,   678,   388,   593,   350,   594,   695,   389,
     680,   737,   327,   699,   647,   690,   529,   738,   739,   320,
     426,   647,   741,   353,   529,   426,   729,   320,   529,   708,
     710,   354,   701,   384,   385,   386,   721,   743,   749,   771,
     426,   426,   647,   715,   615,   351,   616,   702,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   355,   320,
     384,   385,   386,   740,   778,   742,   356,   647,   786,   756,
     326,   647,   728,   746,   789,   747,   748,   647,   793,   413,
     414,   647,   750,   384,   385,   386,   518,   361,   479,   315,
     768,   759,   363,   796,   425,   674,   647,   763,   367,   764,
     364,   745,   384,   385,   386,   326,   384,   385,   386,   369,
     139,   781,   140,   371,   141,   529,   142,   757,   629,   630,
     788,   753,   774,   388,   370,   649,   426,   489,   389,   765,
     705,   426,   320,   731,   732,   372,   551,   552,   529,   553,
     554,   559,   560,   573,   573,   401,   373,   390,   772,   415,
     388,   417,   775,   574,   574,   389,   320,   529,   416,   418,
     174,   529,   175,   176,   177,   178,   179,   180,   181,   182,
     432,   776,   529,   388,   183,   184,   185,   529,   389,   186,
     433,     2,   187,   188,   129,   434,   435,   436,   189,   190,
     787,   437,   388,   438,   792,   439,   388,   389,   440,   442,
     461,   389,   471,   464,   462,   485,   502,   486,   191,   192,
     193,   487,   194,   195,    61,    62,     6,     7,     8,     9,
      10,    11,    12,   196,   197,    15,    16,   198,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   199,   200,   201,   202,
     203,   155,   204,   205,   206,   207,   208,   209,   210,   211,
     488,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,    36,   225,   506,   497,   509,     2,
     511,   516,   522,   226,   227,   228,   229,   230,   231,   577,
     582,   584,   591,   596,   597,   602,   232,   102,   429,   174,
     621,   175,   176,   177,   178,   179,   180,   181,   182,   612,
     618,   619,   622,   183,   184,   185,   628,   635,   186,   641,
       2,   187,   188,   129,   645,   648,    18,   189,   190,    21,
      22,    23,    24,    25,    26,   658,    28,    29,    30,    31,
      32,    33,    34,    35,   662,   663,   664,   191,   192,   193,
     670,   194,   195,    61,    62,     6,     7,     8,     9,    10,
      11,    12,   196,   197,    15,    16,   198,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,   199,   200,   201,   202,   203,
     671,   204,   205,   206,   207,   208,   209,   210,   211,   637,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,    36,   225,   477,   109,   672,   675,   676,
     697,   110,   226,   227,   228,   229,   230,   231,   677,   723,
     724,   726,   733,   725,   735,   232,   102,   623,   174,   744,
     175,   176,   177,   178,   179,   180,   181,   182,   751,   752,
     758,   773,   183,   184,   185,   760,   761,   186,   111,     2,
     187,   188,   129,   112,   762,   777,   189,   190,   782,   113,
     114,   115,   785,   562,   116,   117,   118,   119,   120,   565,
     603,   423,   465,   561,   309,   171,   191,   192,   193,   563,
     194,   195,    61,    62,     6,     7,     8,     9,    10,    11,
      12,   196,   197,    15,    16,   198,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   199,   200,   201,   202,   203,   564,
     204,   205,   206,   207,   208,   209,   210,   211,   620,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    36,   225,    98,    72,   302,   493,   652,   617,
     496,   226,   227,   228,   229,   230,   231,   657,   576,   718,
     362,   581,   285,    99,   232,   102,     2,   443,   669,    62,
       3,     7,     8,     9,    10,    11,     0,    13,    14,     0,
       0,    17,     0,    19,    20,     0,     0,     0,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,     0,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,     1,     0,   112,     0,     0,     0,     0,    80,   113,
     114,   115,     0,     0,   116,   117,   118,   119,   120,     0,
       0,     0,     2,     0,     0,     0,     3,     0,     0,    36,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    37,     0,     0,     0,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,     0,     0,   311,
       0,     0,     0,   188,   129,    36,     0,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,   191,   192,
       0,     0,   194,   195,     0,   175,   176,   177,   178,   179,
     180,   181,   182,   312,   313,     0,     0,   183,   184,   185,
       0,     0,   311,     0,     0,     0,   188,   129,     0,     0,
       0,   189,   190,     0,     0,     0,   199,   200,     0,     0,
       0,     0,     0,     0,     0,   207,     0,     0,     0,     2,
       0,   191,   192,     0,     0,   194,   195,     0,     0,     0,
       0,     0,     0,   224,     0,   225,   312,   313,     0,     0,
       0,     0,     0,   226,   227,   228,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,     0,   314,   673,   199,
     200,   421,   422,     0,    16,     0,    18,     0,   207,    21,
      22,    23,    24,    25,    26,     0,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,   224,     0,   225,     0,
       0,     0,     0,     0,     0,     0,   226,   227,   228,   229,
     230,   231,   175,   176,   177,   178,   179,   180,   181,   182,
     314,     0,     0,     0,   183,   184,   185,     0,     0,   311,
       0,     2,     0,   188,   129,     0,     0,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
       0,     0,   194,   195,    61,    62,     6,     7,     8,     9,
      10,    11,    12,   196,   197,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   199,   200,     0,     0,
       0,     0,     0,     0,     0,   207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,    36,   225,     0,     0,     0,     0,
       0,     0,     0,   226,   227,   228,   229,   230,   231,     0,
       0,     0,     0,     0,     0,     0,   232,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,     0,   183,
     184,   185,     0,     0,   311,     0,     0,     0,   188,   129,
       0,     0,     0,   189,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   191,   192,     0,     0,   194,   195,     0,
     175,   176,   177,   178,   179,   180,   181,   182,   312,   313,
       0,     0,   183,   184,   185,     0,     0,   311,     0,     0,
       0,   188,   129,     0,     0,     0,   189,   190,     0,     0,
       0,   199,   200,     0,     0,     0,     0,     0,     0,     0,
     207,     0,     0,     0,     0,     0,   191,   192,     0,     0,
     194,   195,     0,     0,     0,     0,     0,     0,   224,     0,
     225,   312,   313,     0,     0,     0,     0,     0,   226,   227,
     228,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,   365,     0,     0,   199,   200,     0,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,     0,     0,     0,     0,     0,     0,
       0,   226,   227,   228,   229,   230,   231,     0,     0,     0,
       0,     0,     0,   374,   654,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,     0,   183,   184,   185,
       0,     0,   311,     0,     2,     0,   188,   129,     0,     0,
       0,   189,   190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   191,   192,     0,     0,   194,   195,     0,    62,     0,
       7,     8,     9,    10,    11,     0,   196,   197,     0,     0,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,   199,
     200,     0,     0,     0,     0,     0,     0,     0,   207,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,     0,   225,     0,
       0,     0,     0,     0,     0,     0,   226,   227,   228,   229,
     230,   231,   526,     0,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,     0,   183,   184,   185,     0,
       0,   311,     0,     0,     0,   188,   129,     0,     0,     0,
     189,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,     0,     0,   194,   195,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   312,   313,     0,     0,     0,
       0,   587,     0,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,   199,   200,
     311,     0,     0,     0,   188,   129,     0,   207,     0,   189,
     190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,     0,   225,   527,   191,
     192,     0,     0,   194,   195,   226,   227,   228,   229,   230,
     231,     0,     0,     0,   312,   313,     0,     0,     0,     0,
     374,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,   199,   200,   311,
       0,     0,     0,   188,   129,     0,   207,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,   225,   588,   191,   192,
       0,     0,   194,   195,   226,   227,   228,   229,   230,   231,
       0,     0,     0,   312,   313,     0,     0,     0,     0,   530,
       0,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,     0,   183,   184,   185,   199,   200,   311,     0,
       0,     0,   188,   129,     0,   207,     0,   189,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,   225,     0,   191,   192,     0,
       0,   194,   195,   226,   227,   228,   229,   230,   231,     0,
       0,     0,   312,   313,     0,     0,     0,     0,   324,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,   199,   200,   311,     0,     0,
       0,   188,   129,     0,   207,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,     0,   225,     0,   191,     0,     0,     0,
     194,   195,   226,   227,   228,   229,   230,   231,     0,     0,
     514,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,     0,     0,   311,
       0,     0,     0,   188,   199,   200,     0,     0,     0,     0,
       0,     0,     0,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,     0,     0,   325,     0,     0,     0,
       0,   226,   227,   228,   229,   230,   231,   175,   176,   177,
     178,   179,   180,   181,   182,   711,   712,   713,   714,   183,
     184,   185,     0,     0,   311,     0,   199,   200,   188,   129,
       0,     0,     0,   189,   190,   207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   191,   192,   342,     0,   194,   195,     0,
     175,   176,   177,   178,   179,   180,   181,   182,   312,   313,
       0,     0,   183,   184,   185,     0,     0,   311,     0,     0,
       0,   188,   129,     0,     0,     0,   189,   190,     0,     0,
       0,   199,   200,     0,     0,     0,     0,     0,     0,     0,
     207,     0,     0,     0,     0,     0,   191,   192,     0,     0,
     194,   195,     0,     0,     0,     0,     0,     0,   224,     0,
     225,   312,   313,     0,     0,     0,     0,     0,   226,   227,
     228,   229,   230,   231,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,   199,   200,   183,   184,   185,     0,
       0,   311,     0,   207,     0,   188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,   535,     0,     0,     0,     0,     0,
       0,   226,   227,   228,   229,   230,   231,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,     0,   183,
     184,   185,     0,     0,   311,     0,     0,     0,   188,   129,
       0,     0,     0,   189,   190,     0,     0,     0,   199,   200,
       0,     0,     0,     0,     0,     0,     0,   207,     0,     0,
       0,     0,     0,   191,   192,     0,     0,   194,   195,     0,
       0,     0,     0,     0,     0,     0,     0,   342,   312,   313,
       0,     0,     0,     0,     0,     0,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,     0,   183,   184,
     185,   199,   200,   311,     0,     0,     0,   188,   129,     0,
     207,     0,   189,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,     0,
     225,   632,   191,   192,     0,     0,   194,   195,   226,   227,
     228,   229,   230,   231,     0,     0,     0,   312,   313,     0,
       0,     0,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,     0,   183,   184,   185,
     199,   200,   311,     0,     0,     0,   188,   129,     0,   207,
       0,   189,   190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
     691,   191,   192,     0,     0,   194,   195,   226,   227,   228,
     229,   230,   231,     0,     0,     0,   312,   313,     0,     0,
       0,     0,     0,     0,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,     0,   183,   184,   185,   199,
     200,   311,     0,     0,     0,   188,   129,     0,   207,     0,
     189,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,     0,   225,   707,
     191,   192,     0,     0,   194,   195,   226,   227,   228,   229,
     230,   231,     0,     0,     0,   312,   313,     0,     0,     0,
       0,     0,     0,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,   199,   200,
     311,     0,     0,     0,   188,   129,     0,   207,     0,   189,
     190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,     0,   225,   709,   191,
     192,     0,     0,   194,   195,   226,   227,   228,   229,   230,
     231,     0,     0,     0,   312,   313,     0,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,   199,   200,   311,
       0,     0,     0,   188,   129,     0,   207,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,   225,   754,   191,   192,
       0,     0,   194,   195,   226,   227,   228,   229,   230,   231,
       0,     0,     0,   312,   313,     0,     0,     0,     0,     0,
       0,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,     0,   183,   184,   185,   199,   200,   311,     0,
       0,     0,   188,   129,     0,   207,     0,   189,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,   225,   769,   191,   192,     0,
       0,   194,   195,   226,   227,   228,   229,   230,   231,     0,
       0,     0,   312,   313,     0,     0,     0,     0,     0,     0,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,     0,   183,   184,   185,   199,   200,   311,     0,     0,
       0,   188,   129,     0,   207,     0,   189,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,     0,   225,   779,   191,   192,     0,     0,
     194,   195,   226,   227,   228,   229,   230,   231,     0,     0,
       0,   312,   313,     0,     0,     0,     0,     0,     0,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
       0,   183,   184,   185,   199,   200,   311,     0,     0,     0,
     188,   129,     0,   207,     0,   189,   190,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,   225,   783,   191,   192,     0,     0,   194,
     195,   226,   227,   228,   229,   230,   231,     0,     0,     0,
     312,   313,     0,     0,     0,     0,     0,     0,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,     0,
     183,   184,   185,   199,   200,   311,     0,     0,     0,   188,
     129,     0,   207,     0,   189,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,     0,   225,   790,   191,   192,     0,     0,   194,   195,
     226,   227,   228,   229,   230,   231,     0,     0,     0,   312,
     313,     0,     0,     0,     0,     0,     0,   175,   176,   177,
     178,   179,   180,   181,   182,     0,     0,     0,     0,   183,
     184,   185,   199,   200,   311,     0,     0,     0,   188,   129,
       0,   207,     0,   189,   190,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
       0,   225,   794,   191,   192,     0,     0,   194,   195,   226,
     227,   228,   229,   230,   231,     0,     0,     0,   312,   313,
       0,     0,     0,     0,     0,     0,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,     0,   183,   184,
     185,   199,   200,   311,     0,     0,     0,   188,   129,     0,
     207,     0,   189,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,     0,
     225,     0,   191,     0,     0,     0,   194,   195,   226,   227,
     228,   229,   230,   231,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,     0,   183,   184,   185,
     199,   200,   311,     0,     0,     0,   188,   129,     0,   207,
       0,   189,   190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,     0,   225,
       0,   191,   610,     0,     0,   194,   195,   226,   227,   228,
     229,   230,   231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,     0,   183,   184,   185,   199,
     200,   311,     0,     0,     0,   188,   129,     0,   207,     0,
     189,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   224,     0,   225,     0,
     191,   681,     0,     0,   194,   195,   226,   227,   228,   229,
     230,   231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,     0,   183,   184,   185,   199,   200,
     311,     0,     0,     0,   188,   129,     0,   207,     0,   189,
     190,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,     0,   342,     0,   191,
       0,     0,     0,   194,   195,   226,   227,   228,   229,   230,
     231,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,     0,   183,   184,   185,   199,   200,   311,
       0,     0,     0,   188,   129,     0,   207,     0,   189,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,     0,   345,     0,   191,     0,
       0,     0,   194,   195,   226,   227,   228,   229,   230,   231,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   606,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   199,   200,     0,     0,
       0,     0,     0,     0,    76,   207,     2,     0,     0,    77,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,     0,   225,     0,     0,     0,     0,
       0,     0,     0,   226,   227,   228,   229,   230,   231,    61,
      62,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   606,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     0,     0,     0,     0,     0,     0,    36,
     478,   607,   479,     0,     0,     0,     0,     0,    79,    80,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,    62,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,   175,   176,   177,
     178,   179,   180,   181,   182,     2,     0,     0,     0,   183,
     184,   185,     0,     0,   311,     0,     0,     0,   188,     0,
       0,     0,     0,     0,     0,    36,   518,   607,   479,     0,
       0,     0,     0,     0,    79,    80,     0,     0,     0,    62,
       0,     7,     8,     9,    10,    11,     0,    13,    14,     0,
       0,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   199,   200,     0,     0,     0,     0,     2,     0,     0,
     207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     342,     0,   687,     0,     0,   688,     0,     0,     2,     0,
       0,    62,   163,     7,     8,     9,    10,    11,     0,    13,
      14,     0,     0,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    62,     0,     7,     8,     9,    10,    11,     2,
      13,    14,     0,     0,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    62,     0,     7,     8,     9,    10,    11,
       0,    13,    14,     0,   170,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   318,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   333,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     2,     0,     0,   183,   184,
     185,     0,     0,   311,     0,     0,     0,   188,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   339,     0,    61,    62,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     458,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     199,   200,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     2,     0,     0,     0,     0,     0,     0,    36,     0,
     319,     0,     0,     0,     0,     0,     0,     0,     0,   342,
       0,   767,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    61,    62,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     0,     0,
       0,     0,     0,     0,    36,     0,   459,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      61,    62,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   606,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
      36,     0,   667,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,    62,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,     2,     0,
       0,     0,   444,   445,   446,   447,   448,   449,   450,   451,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   452,
       0,     2,     0,     0,     0,     0,    36,     0,   679,     0,
       0,    61,    62,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   421,   422,     2,    16,     0,    18,     0,
       0,    21,    22,    23,    24,    25,    26,     0,    28,    29,
      30,    31,    32,    33,    34,    35,   453,   454,     0,     0,
       0,    36,     0,     0,     0,     0,     0,    63,    61,    62,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,     0,     0,     2,    90,    62,     0,     7,     8,     9,
      10,    11,     0,    13,    14,     0,     0,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    61,    62,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,     2,     0,
     331,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,     0,
       0,     0,    62,     0,     7,     8,     9,    10,    11,     0,
      13,    14,     0,     0,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35
};

static const yytype_int16 yycheck[] =
{
     155,     0,   201,    64,     3,   207,   155,    80,    41,    90,
     164,   253,   157,   300,   158,   169,   390,     0,   320,    20,
      86,    87,   206,    80,   320,    38,   193,    21,    67,    20,
     120,   120,    20,    20,   218,    92,   137,    25,    95,   117,
      39,    40,   120,    42,    43,    44,   138,   137,   290,   216,
     139,    50,    51,    92,    21,   372,    95,   201,   225,    20,
      55,    22,   120,    58,    20,   439,    18,    19,    51,    25,
      20,   225,   158,   120,   376,    25,   260,   135,   151,   120,
     376,   265,   120,   120,    33,    34,   228,   229,   230,   231,
     116,   120,   139,   120,   151,   481,   482,   121,   139,   137,
     299,   100,   139,   189,   190,   191,   116,   164,   137,   166,
     137,   125,   169,    20,   171,   201,   130,   131,    25,   138,
     153,   134,   121,   117,    20,   164,   120,   166,   116,    25,
     169,   505,   171,   519,   520,   168,   124,   125,   139,   172,
     226,   227,   228,   229,   230,   231,   291,   120,   139,   132,
     133,   138,    25,   120,   471,   299,   138,   359,   157,   314,
     116,   156,   118,   120,   137,    20,   116,    22,   225,   353,
      25,   373,   121,   122,   166,   342,   478,   138,   345,   171,
     137,    20,   469,    28,    29,    30,   225,   354,   355,   356,
     116,   345,   118,   348,   138,    28,    29,    30,   124,   125,
     367,   117,   369,   358,   120,    28,    29,    30,   117,   116,
      20,   120,    22,   299,   253,    25,   518,   124,   125,    20,
     116,   388,   118,   138,   117,   286,   259,   120,   124,   125,
     137,   117,   387,   116,   120,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   320,   139,   117,
     331,   290,   120,   420,   438,   294,   117,   631,    20,   120,
     402,   403,   404,    20,     3,   639,     5,    20,     7,   643,
       9,   426,   117,   118,   117,   120,   117,   120,   123,   120,
     479,   121,    21,   116,   439,   118,   117,   320,   345,   120,
     123,   117,   291,   116,   120,   118,    28,    29,    30,   117,
     123,   117,   120,   376,   120,     3,   345,     5,   122,     7,
      22,     9,   496,   497,   136,    27,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   136,   479,   138,   409,   410,   411,
     412,     3,     4,     5,     6,     7,     8,     9,    10,   116,
     505,   593,    64,    15,    16,    17,   730,    69,    20,   137,
     138,   442,    24,    75,    76,    77,   137,   138,    80,    81,
      82,    83,    84,    20,    28,    29,    30,    18,    19,   753,
     522,   117,   421,   422,   116,   424,   118,    31,    32,   117,
     471,   123,   120,   479,   117,   138,   117,   120,   772,   120,
     122,   440,   776,   570,   117,   478,   122,   120,   575,   576,
     122,   126,   127,   787,   569,   481,   482,   616,   792,   137,
     117,   117,   116,   120,   120,    87,    88,   629,   120,   117,
     122,     3,   120,     5,    96,     7,   522,     9,   116,    50,
     118,   625,   626,   627,   117,   518,   591,   120,    20,   604,
     634,   116,   636,   118,   116,   604,   118,   612,   491,   121,
     135,   628,   116,   612,   118,   120,    50,   122,   635,   123,
     615,   117,   616,   640,   120,   630,   631,   117,   117,   478,
     120,   120,   117,   135,   639,   120,   688,   486,   643,   656,
     657,   116,   647,    28,    29,    30,   663,   117,   117,   117,
     120,   120,   120,   658,   116,   138,   118,   651,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,   116,   518,
      28,    29,    30,   707,   117,   709,   116,   120,   117,   731,
     616,   120,   687,   717,   117,   719,   720,   120,   117,    35,
      36,   120,   726,    28,    29,    30,   116,    20,   118,   704,
     752,   735,   137,   117,   593,   704,   120,   741,   116,   743,
     137,   716,    28,    29,    30,   651,    28,    29,    30,   116,
       3,   773,     5,   116,     7,   730,     9,   732,   119,   120,
     782,   116,   766,   118,   137,   119,   120,    20,   123,   744,
     119,   120,   591,   119,   120,   116,   405,   406,   753,   407,
     408,   413,   414,   432,   433,   136,   116,   116,   116,   124,
     118,   133,   767,   432,   433,   123,   615,   772,   132,    37,
       1,   776,     3,     4,     5,     6,     7,     8,     9,    10,
     116,   116,   787,   118,    15,    16,    17,   792,   123,    20,
     116,    22,    23,    24,    25,   116,   116,   116,    29,    30,
     116,   116,   118,   135,   116,   116,   118,   123,   136,   136,
     139,   123,   116,   137,   139,   117,    94,   120,    49,    50,
      51,   119,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,   136,    93,    94,    95,    96,    97,    98,    99,   100,
     119,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   137,   135,    94,    22,
      21,   117,   117,   124,   125,   126,   127,   128,   129,    20,
      20,    20,   116,   137,   117,   117,   137,   138,   139,     1,
     117,     3,     4,     5,     6,     7,     8,     9,    10,   136,
     122,   122,   117,    15,    16,    17,   116,   116,    20,   117,
      22,    23,    24,    25,   117,   119,    69,    29,    30,    72,
      73,    74,    75,    76,    77,   136,    79,    80,    81,    82,
      83,    84,    85,    86,   117,    52,   117,    49,    50,    51,
     137,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
     137,    93,    94,    95,    96,    97,    98,    99,   100,    21,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   120,    22,   117,   117,   117,
     137,    27,   124,   125,   126,   127,   128,   129,   119,   117,
     117,    92,   122,   119,    92,   137,   138,   139,     1,   101,
       3,     4,     5,     6,     7,     8,     9,    10,   137,   119,
     122,   119,    15,    16,    17,   137,   137,    20,    64,    22,
      23,    24,    25,    69,   137,   122,    29,    30,   119,    75,
      76,    77,   122,   416,    80,    81,    82,    83,    84,   419,
     473,   253,   297,   415,   153,    95,    49,    50,    51,   417,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,   418,
      93,    94,    95,    96,    97,    98,    99,   100,   491,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,     0,    34,   147,   345,   569,   486,
     351,   124,   125,   126,   127,   128,   129,   576,   433,   660,
     213,   435,   111,    51,   137,   138,    22,   288,   593,    56,
      26,    58,    59,    60,    61,    62,    -1,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,     1,    -1,    69,    -1,    -1,    -1,    -1,   125,    75,
      76,    77,    -1,    -1,    80,    81,    82,    83,    84,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    26,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,   115,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,    49,    50,
      -1,    -1,    53,    54,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    64,    65,    -1,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,
      -1,    29,    30,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    22,
      -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    64,    65,    -1,    -1,
      -1,    -1,    -1,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,   139,    87,
      88,    64,    65,    -1,    67,    -1,    69,    -1,    96,    72,
      73,    74,    75,    76,    77,    -1,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    -1,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   124,   125,   126,   127,
     128,   129,     3,     4,     5,     6,     7,     8,     9,    10,
     138,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    22,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   137,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    64,    65,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    64,    65,    -1,    -1,    -1,    -1,    -1,   124,   125,
     126,   127,   128,   129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   137,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   124,   125,   126,   127,   128,   129,    -1,    -1,    -1,
      -1,    -1,    -1,     1,   137,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    50,    -1,    -1,    53,    54,    -1,    56,    -1,
      58,    59,    60,    61,    62,    -1,    64,    65,    -1,    -1,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   124,   125,   126,   127,
     128,   129,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,
      20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,    49,
      50,    -1,    -1,    53,    54,   124,   125,   126,   127,   128,
     129,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,   117,    49,    50,
      -1,    -1,    53,    54,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    87,    88,    20,    -1,
      -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    49,    50,    -1,
      -1,    53,    54,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    64,    65,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    87,    88,    20,    -1,    -1,
      -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    49,    -1,    -1,    -1,
      53,    54,   124,   125,   126,   127,   128,   129,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,    -1,    -1,   119,    -1,    -1,    -1,
      -1,   124,   125,   126,   127,   128,   129,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    -1,    20,    -1,    87,    88,    24,    25,
      -1,    -1,    -1,    29,    30,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    50,   116,    -1,    53,    54,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    64,    65,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    64,    65,    -1,    -1,    -1,    -1,    -1,   124,   125,
     126,   127,   128,   129,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    87,    88,    15,    16,    17,    -1,
      -1,    20,    -1,    96,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,   117,    -1,    -1,    -1,    -1,    -1,
      -1,   124,   125,   126,   127,   128,   129,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    -1,    29,    30,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,
      96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,   117,    49,    50,    -1,    -1,    53,    54,   124,   125,
     126,   127,   128,   129,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
     117,    49,    50,    -1,    -1,    53,    54,   124,   125,   126,
     127,   128,   129,    -1,    -1,    -1,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,
      88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,
      49,    50,    -1,    -1,    53,    54,   124,   125,   126,   127,
     128,   129,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,
      20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,    49,
      50,    -1,    -1,    53,    54,   124,   125,   126,   127,   128,
     129,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,   117,    49,    50,
      -1,    -1,    53,    54,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    87,    88,    20,    -1,
      -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,   117,    49,    50,    -1,
      -1,    53,    54,   124,   125,   126,   127,   128,   129,    -1,
      -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    87,    88,    20,    -1,    -1,
      -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,   116,   117,    49,    50,    -1,    -1,
      53,    54,   124,   125,   126,   127,   128,   129,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    87,    88,    20,    -1,    -1,    -1,
      24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,   116,   117,    49,    50,    -1,    -1,    53,
      54,   124,   125,   126,   127,   128,   129,    -1,    -1,    -1,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    87,    88,    20,    -1,    -1,    -1,    24,
      25,    -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     114,    -1,   116,   117,    49,    50,    -1,    -1,    53,    54,
     124,   125,   126,   127,   128,   129,    -1,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    87,    88,    20,    -1,    -1,    -1,    24,    25,
      -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,   116,   117,    49,    50,    -1,    -1,    53,    54,   124,
     125,   126,   127,   128,   129,    -1,    -1,    -1,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,
      96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
     116,    -1,    49,    -1,    -1,    -1,    53,    54,   124,   125,
     126,   127,   128,   129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,
      -1,    49,   119,    -1,    -1,    53,    54,   124,   125,   126,
     127,   128,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,
      88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,
      49,   119,    -1,    -1,    53,    54,   124,   125,   126,   127,
     128,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,
      20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    49,
      -1,    -1,    -1,    53,    54,   124,   125,   126,   127,   128,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    49,    -1,
      -1,    -1,    53,    54,   124,   125,   126,   127,   128,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    96,    22,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   124,   125,   126,   127,   128,   129,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,   115,
     116,   117,   118,    -1,    -1,    -1,    -1,    -1,   124,   125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,     3,     4,     5,
       6,     7,     8,     9,    10,    22,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    -1,    -1,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    56,
      -1,    58,    59,    60,    61,    62,    -1,    64,    65,    -1,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,    -1,   118,    -1,    -1,   121,    -1,    -1,    22,    -1,
      -1,    56,   139,    58,    59,    60,    61,    62,    -1,    64,
      65,    -1,    -1,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    56,    -1,    58,    59,    60,    61,    62,    22,
      64,    65,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    -1,    58,    59,    60,    61,    62,
      -1,    64,    65,    -1,   139,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    22,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
      -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    22,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    22,    -1,    -1,    -1,    -1,   115,    -1,   117,    -1,
      -1,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    64,    65,    22,    67,    -1,    69,    -1,
      -1,    72,    73,    74,    75,    76,    77,    -1,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    -1,    -1,
      -1,   115,    -1,    -1,    -1,    -1,    -1,   121,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
      -1,    -1,    -1,    22,   121,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    -1,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    22,    -1,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    58,    59,    60,    61,    62,    -1,
      64,    65,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    22,    26,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,   115,   137,   170,   171,
     174,   175,   176,   182,   183,   185,   188,   189,   190,   197,
     200,   251,   252,   253,   262,   263,   265,   270,   271,   272,
     137,    55,    56,   121,   175,    18,    19,   138,   116,   121,
      20,   138,   196,   116,   175,   175,    20,    25,   116,   124,
     125,   137,   180,   181,   202,   204,   205,   206,   175,   175,
     121,   175,   138,    20,    22,   138,   187,   175,     0,   252,
     264,   137,   138,   219,   221,   137,   221,    18,    19,    22,
      27,    64,    69,    75,    76,    77,    80,    81,    82,    83,
      84,   122,   255,   256,   257,   258,   259,   260,   261,    25,
     268,   269,   138,   138,   183,   184,    20,   172,   173,     3,
       5,     7,     9,   203,   196,   198,   199,   138,   116,   202,
     200,   201,   205,   120,   137,   136,   254,   116,   118,   204,
     204,    20,   203,   139,   183,   186,   191,   192,   193,   200,
     139,   191,   175,   139,     1,     3,     4,     5,     6,     7,
       8,     9,    10,    15,    16,    17,    20,    23,    24,    29,
      30,    49,    50,    51,    53,    54,    64,    65,    68,    87,
      88,    89,    90,    91,    93,    94,    95,    96,    97,    98,
      99,   100,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   116,   124,   125,   126,   127,
     128,   129,   137,   142,   143,   144,   145,   146,   147,   148,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   165,   166,   167,   169,   170,   175,
     215,   216,   217,   218,   221,   222,   223,   224,   227,   228,
     229,   230,   232,   237,   239,   244,   245,   246,   247,   248,
     249,   250,   269,    20,    20,   256,   175,    20,   120,   122,
     121,   116,   170,   170,   120,   139,   117,   120,   122,   136,
     120,   139,   198,    20,   177,   178,   117,   200,   205,   181,
     202,    20,    64,    65,   138,   166,   213,   221,     1,   117,
     175,   207,   208,   209,     1,   119,   150,   162,   168,   122,
     122,   121,   193,   139,   192,   194,   195,   202,   193,   139,
     202,   137,   116,   150,   150,   116,   150,   167,   116,    50,
      50,   138,   168,   135,   116,   116,   116,   216,   118,   121,
     145,    20,   244,   137,   137,   137,   167,   116,   216,   116,
     137,   116,   116,   116,     1,   167,   193,   210,   150,   150,
     151,   151,   151,   151,    28,    29,    30,   116,   118,   123,
     116,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,   136,   125,   130,   131,   126,   127,    31,    32,    33,
      34,   121,   122,    35,    36,   124,   132,   133,    37,    38,
     134,    64,    65,   164,   171,   183,   120,   137,   216,   139,
     216,   220,   116,   116,   116,   116,   116,   116,   135,   116,
     136,   269,   136,   260,     3,     4,     5,     6,     7,     8,
       9,    10,    20,    87,    88,   164,   266,   267,     1,   117,
     207,   139,   139,   183,   137,   172,   168,   139,   199,   120,
     139,   116,   117,   120,   213,   214,   117,   120,   116,   118,
     202,   205,   206,   211,   212,   117,   120,   119,   119,    20,
     203,   120,   137,   210,   137,   166,   222,   135,   216,   167,
     167,   167,    94,   166,   145,   116,   137,   137,   167,    94,
     167,    21,   141,   141,     1,   145,   117,   117,   116,   205,
     206,   211,   117,    20,    22,    25,     1,   117,   149,   166,
       1,   167,    20,    22,    25,   117,   149,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   151,   151,
     151,   152,   152,   153,   153,   154,   154,   154,   154,   155,
     155,   156,   157,   158,   159,   160,   167,   183,   183,   116,
     118,   183,   166,   169,   223,   226,   226,    20,   231,   235,
     236,   236,    20,   233,    20,   238,   216,     1,   117,   149,
     183,   116,   203,   120,   122,   117,   137,   117,   139,   141,
     179,   203,   117,   178,   120,   139,     1,   117,   207,   211,
     119,   168,   136,   212,   212,   116,   118,   209,   122,   122,
     195,   117,   117,   139,   216,   117,   117,   117,   116,   119,
     120,   116,   117,   149,   117,   116,   117,    21,   117,   120,
     120,   117,   117,   120,   151,   117,   117,   120,   119,   119,
     117,   135,   214,   167,   137,   167,   225,   225,   136,   117,
     120,   117,   117,    52,   117,   117,     1,   117,   207,   266,
     137,   137,   117,   139,   213,   117,   117,   119,   213,   117,
     207,   119,   168,   216,   216,   216,   167,   118,   121,   145,
     166,   117,   149,   117,   216,   167,   216,   137,   149,   167,
     149,   166,   162,   117,   120,   119,   137,   117,   167,   117,
     167,    11,    12,    13,    14,   166,   234,   240,   235,   241,
     242,   167,   117,   117,   117,   119,    92,   117,   166,   145,
     116,   119,   120,   122,   117,    92,   117,   117,   117,   117,
     216,   117,   216,   117,   101,   166,   216,   216,   216,   117,
     216,   137,   119,   116,   117,   149,   145,   166,   122,   216,
     137,   137,   137,   216,   216,   166,   243,   118,   145,   117,
     149,   117,   116,   119,   216,   166,   116,   122,   117,   117,
     149,   145,   119,   117,   149,   122,   117,   116,   145,   117,
     117,   149,   116,   117,   117,   149,   117
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   140,   141,   141,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   143,   143,   143,   143,   143,   143,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   144,   144,   144,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     145,   145,   146,   147,   147,   148,   148,   148,   148,   148,
     148,   148,   149,   149,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   151,   151,
     152,   152,   152,   152,   153,   153,   153,   154,   154,   154,
     155,   155,   155,   155,   155,   156,   156,   156,   157,   157,
     158,   158,   159,   159,   160,   160,   161,   161,   162,   162,
     163,   163,   163,   164,   164,   164,   164,   165,   165,   165,
     165,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   167,   167,   168,   169,   170,   170,   171,
     172,   173,   173,   174,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   176,   177,
     177,   178,   178,   179,   179,   180,   180,   181,   181,   182,
     182,   182,   182,   182,   183,   183,   183,   183,   184,   184,
     185,   185,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   186,   186,   187,   187,   188,   189,   189,
     189,   189,   189,   190,   191,   191,   192,   193,   193,   193,
     193,   194,   194,   195,   196,   197,   197,   197,   197,   197,
     198,   198,   199,   199,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   201,   201,   202,   202,
     202,   203,   203,   203,   203,   204,   204,   204,   204,   204,
     204,   204,   204,   204,   205,   205,   205,   205,   206,   207,
     208,   208,   208,   209,   209,   209,   209,   210,   210,   211,
     211,   211,   211,   211,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   213,   213,   213,   214,   214,   215,   216,
     216,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   217,   217,   218,   218,   218,   219,   220,   221,
     221,   222,   222,   223,   223,   224,   224,   224,   224,   224,
     225,   225,   226,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   234,   234,   234,   235,   235,   236,   236,   237,
     238,   239,   239,   239,   239,   239,   239,   239,   239,   240,
     239,   241,   239,   242,   239,   243,   239,   244,   245,   245,
     245,   245,   245,   246,   247,   248,   249,   249,   250,   251,
     251,   251,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   254,   253,   255,   255,   256,   256,   256,   256,   256,
     256,   256,   256,   256,   257,   257,   258,   258,   259,   260,
     260,   260,   261,   261,   262,   264,   263,   265,   265,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   267,   267,   268,   269,   269,   270,   270,   270,   271,
     271,   271,   272,   272
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     4,     8,     7,    10,     9,    11,    10,    12,
      11,    14,    13,     7,     6,    10,     9,     4,     6,     4,
       1,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       2,     2,     1,     3,     4,     1,     3,     4,     4,     3,
       4,     4,     1,     3,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     4,     4,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
       1,     2,     2,     1,     2,     2,     2,     1,     2,     5,
       5,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     1,     1,     2,     3,     4,
       1,     1,     3,     4,     1,     2,     1,     2,     1,     2,
       1,     4,     4,     2,     1,     2,     1,     2,     6,     1,
       3,     1,     4,     1,     1,     1,     3,     1,     3,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     1,     1,     2,     1,     4,
       4,     3,     3,     1,     1,     2,     3,     2,     1,     1,
       2,     1,     3,     1,     1,     4,     5,     5,     6,     2,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     3,
       4,     4,     3,     4,     1,     2,     2,     3,     1,     1,
       1,     3,     2,     2,     4,     2,     1,     1,     2,     1,
       1,     2,     1,     2,     3,     2,     3,     3,     4,     2,
       3,     3,     4,     1,     3,     4,     1,     3,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     4,     3,     1,     1,     2,
       3,     1,     2,     1,     2,     5,     7,     5,     7,     5,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     4,     1,     3,     1,
       1,     5,     5,     7,     7,     6,     7,     6,     7,     0,
       6,     0,     6,     0,     6,     0,     8,     1,     3,     2,
       2,     2,     3,     2,     3,     4,     5,     7,     7,     1,
       2,     2,     1,     1,     1,     1,     5,     5,     5,     1,
       1,     0,     4,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     2,     4,     2,     1,
       1,     1,     1,     3,     4,     0,     4,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     4,     1,     7,     6,     7,     8,
       7,     8,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_TOKEN_FLOAT16_CONSTANT: /* TOKEN_FLOAT16_CONSTANT  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2894 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_IDENTIFIER: /* TOKEN_IDENTIFIER  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2900 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_STRING_LITERAL: /* TOKEN_STRING_LITERAL  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2906 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TYPE_NAME: /* TOKEN_TYPE_NAME  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2912 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TEMPLATE_NAME: /* TOKEN_TEMPLATE_NAME  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2918 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_INTRINSIC_CALL: /* TOKEN_INTRINSIC_CALL  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2924 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_string_constant: /* string_constant  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2930 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

    case YYSYMBOL_intrinsic_name: /* intrinsic_name  */
#line 292 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 2936 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 301 "src/parse.yy"
    {
        (yyval.stringVal) = new std::string(*(yyvsp[0].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3237 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 306 "src/parse.yy"
    {
        std::string *p_str_cst = new std::string();
        p_str_cst->append(*(yyvsp[-1].stringVal));
        p_str_cst->append(*(yyvsp[0].stringVal));
        (yyval.stringVal) = p_str_cst;
        // Allocated in lStringConst
        lCleanUpString((yyvsp[-1].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3251 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 318 "src/parse.yy"
                       {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = nullptr;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, {}, TemplateArgs(), (yylsp[0]));
        }
        if ((yyval.expr) == nullptr) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 3276 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 338 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 3285 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 342 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 3294 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 346 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 3303 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 350 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 3312 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 354 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 3321 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 358 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 3330 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 362 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 3339 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 366 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 3348 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT16_CONSTANT  */
#line 370 "src/parse.yy"
                             {
         std::string sval = *(yyvsp[0].stringVal);
         lCleanUpString((yyvsp[0].stringVal));
         llvm::Type *hType = llvm::Type::getHalfTy(*g->ctx);
         const llvm::fltSemantics &FS = hType->getFltSemantics();
         llvm::APFloat f16(FS, sval);
         (yyval.expr) = new ConstExpr(AtomicType::UniformFloat16->GetAsConstType(),
                           f16, (yylsp[0]));
    }
#line 3362 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 379 "src/parse.yy"
                           {
        llvm::APFloat f(yylval.floatVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           f, (yylsp[0]));
    }
#line 3372 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 384 "src/parse.yy"
                            {
        llvm::APFloat d(yylval.doubleVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           d, (yylsp[0]));
    }
#line 3382 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_TRUE  */
#line 389 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 3390 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_FALSE  */
#line 392 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 3398 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 18: /* primary_expression: TOKEN_NULL  */
#line 395 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 3406 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' expression ')'  */
#line 400 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 3412 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 20: /* primary_expression: '(' error ')'  */
#line 401 "src/parse.yy"
                    { (yyval.expr) = nullptr; }
#line 3418 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 406 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 3428 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 412 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 3438 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 419 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3448 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 425 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3458 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 432 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3468 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 438 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3478 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 444 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3488 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 450 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3498 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 457 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3507 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 462 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3516 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 467 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3525 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 472 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3534 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 479 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3544 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 485 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3554 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 491 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3564 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 36: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 497 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 3574 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 37: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ')'  */
#line 506 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-1].expr), new ExprList((yylsp[0])), Union((yylsp[-3]),(yylsp[0])), false, nullptr, true);
      }
#line 3582 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 38: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ',' argument_expression_list ')'  */
#line 510 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-5]),(yylsp[0])), false, nullptr, true);
      }
#line 3590 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 39: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' error ')'  */
#line 514 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3596 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 520 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3602 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression '[' error ']'  */
#line 522 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3608 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 44: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 525 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3617 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 45: /* postfix_expression: postfix_expression '.' TOKEN_TYPE_NAME  */
#line 532 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3626 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 46: /* postfix_expression: postfix_expression '.' TOKEN_TEMPLATE_NAME  */
#line 537 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3635 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 47: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 542 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3644 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 48: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TYPE_NAME  */
#line 549 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3653 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 49: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TEMPLATE_NAME  */
#line 554 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 3662 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 50: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 559 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3668 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 51: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 561 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3674 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 52: /* intrinsic_name: TOKEN_INTRINSIC_CALL  */
#line 566 "src/parse.yy"
      {
          (yyval.stringVal) = (yyvsp[0].stringVal);
      }
#line 3682 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 53: /* intrincall_expression: intrinsic_name '(' ')'  */
#line 573 "src/parse.yy"
      {
          std::string *name = (yyvsp[-2].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, nullptr, Union((yylsp[-2]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = nullptr;
          if (sym != nullptr)
              fSym = new FunctionSymbolExpr(fname, funcs, {}, TemplateArgs(), (yylsp[-2]));
          (yyval.expr) = new FunctionCallExpr(fSym, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          delete name;
      }
#line 3699 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 54: /* intrincall_expression: intrinsic_name '(' argument_expression_list ')'  */
#line 586 "src/parse.yy"
      {
          std::string *name = (yyvsp[-3].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = nullptr;
          if (sym != nullptr)
              fSym = new FunctionSymbolExpr(fname, funcs, {}, TemplateArgs(), (yylsp[-3]));
          (yyval.expr) = new FunctionCallExpr(fSym, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          delete name;
      }
#line 3716 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 56: /* funcall_expression: postfix_expression '(' ')'  */
#line 603 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3722 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 57: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 605 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3728 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 58: /* funcall_expression: postfix_expression '(' error ')'  */
#line 607 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 3734 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 59: /* funcall_expression: simple_template_id '(' ')'  */
#line 609 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          const std::string name = (yyvsp[-2].simpleTemplateID)->first->name;
          std::vector<Symbol *> funcs;
          m->symbolTable->LookupFunction(name.c_str(), &funcs);
          std::vector<TemplateSymbol *> funcTempls;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcs.size() > 0 || funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-2].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcs, funcTempls, *templArgs, (yylsp[-2]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          } else {
              Error((yylsp[-2]), "No matching functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
      }
#line 3760 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 60: /* funcall_expression: simple_template_id '(' argument_expression_list ')'  */
#line 631 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          const std::string name = (yyvsp[-3].simpleTemplateID)->first->name;
          std::vector<Symbol *> funcs;
          m->symbolTable->LookupFunction(name.c_str(), &funcs);
          std::vector<TemplateSymbol *> funcTempls;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcs.size() > 0 || funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-3].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcs, funcTempls, *templArgs, (yylsp[-3]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          } else {
              Error((yylsp[-3]), "No matching functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 3786 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 61: /* funcall_expression: simple_template_id '(' error ')'  */
#line 653 "src/parse.yy"
      {
          (yyval.expr) = nullptr;

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 3797 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 62: /* argument_expression_list: assignment_expression  */
#line 662 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3803 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 63: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 664 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3818 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 67: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 681 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3824 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 68: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 683 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3830 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 69: /* unary_expression: '&' unary_expression  */
#line 685 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3836 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 70: /* unary_expression: '*' unary_expression  */
#line 687 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3842 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 71: /* unary_expression: '+' cast_expression  */
#line 689 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3848 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 72: /* unary_expression: '-' cast_expression  */
#line 691 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3854 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 73: /* unary_expression: '~' cast_expression  */
#line 693 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3860 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 74: /* unary_expression: '!' cast_expression  */
#line 695 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3866 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 75: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 697 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3872 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 76: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 699 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3878 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 77: /* unary_expression: TOKEN_ALLOCA '(' assignment_expression ')'  */
#line 701 "src/parse.yy"
      {
          (yyval.expr) = new AllocaExpr((yyvsp[-1].expr), Union((yylsp[-3]), (yylsp[0])));
      }
#line 3886 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 79: /* cast_expression: '(' type_name ')' cast_expression  */
#line 709 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3894 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 81: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 717 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3900 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 82: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 719 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3906 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 83: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 721 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3912 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 85: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 727 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3918 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 86: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 729 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3924 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 88: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 735 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3930 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 89: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 737 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3936 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 91: /* relational_expression: relational_expression '<' shift_expression  */
#line 743 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3942 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 92: /* relational_expression: relational_expression '>' shift_expression  */
#line 745 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3948 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 93: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 747 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3954 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 94: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 749 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3960 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 96: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 755 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3966 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 97: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 757 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3972 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 99: /* and_expression: and_expression '&' equality_expression  */
#line 763 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3978 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 101: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 769 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3984 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 103: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 775 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3990 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 105: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 781 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3996 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 107: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 787 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4002 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 109: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 793 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 4008 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 110: /* rate_qualified_new: TOKEN_NEW  */
#line 797 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 4014 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 111: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 798 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 4020 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 112: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 799 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 4026 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 113: /* rate_qualified_type_specifier: type_specifier  */
#line 803 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 4032 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 114: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 805 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 4047 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 115: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 816 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 4062 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 116: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 827 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == nullptr) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = nullptr;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = nullptr;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 4087 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 118: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 852 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), nullptr, nullptr, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 4095 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 119: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 856 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), nullptr, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 4103 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 120: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 860 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), nullptr, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 4111 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 122: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 868 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4117 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 123: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 870 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4123 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 124: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 872 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4129 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 125: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 874 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4135 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 126: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 876 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4141 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 127: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 878 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4147 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 128: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 880 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4153 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 129: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 882 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4159 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 130: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 884 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4165 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 131: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 886 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4171 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 132: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 888 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4177 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 134: /* expression: expression ',' assignment_expression  */
#line 894 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4183 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 136: /* declaration_statement: declaration  */
#line 903 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == nullptr) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = nullptr;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == nullptr)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = nullptr;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 4210 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 137: /* declaration: declaration_specifiers ';'  */
#line 929 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 4218 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 138: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 933 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
          // init_declarator_list returns vector of declarators, its copy is
          // saved in Declaration constructor, so it is not needed anymore.
          delete (yyvsp[-1].declarators);
      }
#line 4229 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 139: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 943 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 4235 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 140: /* declspec_item: TOKEN_IDENTIFIER  */
#line 948 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yyvsp[0].stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4247 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 141: /* declspec_list: declspec_item  */
#line 959 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
        // declspec_item returns pair that was copied so it is not needed anymore.
        delete (yyvsp[0].declspecPair);
    }
#line 4258 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 142: /* declspec_list: declspec_list ',' declspec_item  */
#line 966 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != nullptr) {
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
            // declspec_item returns pair that was copied so it is not needed anymore.
            delete (yyvsp[0].declspecPair);
        }
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 4271 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 143: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 978 "src/parse.yy"
    {
        // declspec_list returns heap allocated vector that passed up here.
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 4280 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 144: /* declaration_specifiers: storage_class_specifier  */
#line 986 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, (yyvsp[0].storageClass));
      }
#line 4288 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 145: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 990 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 4306 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 146: /* declaration_specifiers: declspec_specifier  */
#line 1004 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != nullptr) {
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete (yyvsp[0].declspecList);
          }
      }
#line 4319 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 147: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 1013 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != nullptr && declSpecList != nullptr) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);

              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete declSpecList;
          }
          (yyval.declSpecs) = ds;
      }
#line 4336 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 148: /* declaration_specifiers: soa_width_specifier  */
#line 1026 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 4346 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 149: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 1032 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 4361 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 150: /* declaration_specifiers: type_specifier  */
#line 1043 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 4369 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 151: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 1047 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 4379 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 152: /* declaration_specifiers: type_specifier '<' TOKEN_IDENTIFIER '>'  */
#line 1053 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          const char *name = (yyvsp[-1].stringVal)->c_str();
          Symbol *s = m->symbolTable->LookupVariable(name);
          if (s) {
            ds->vectorSize = s;
          } else {
            Error((yylsp[-1]), "Unknown identifier \"%s\" is used to specify the size of a vector type.", name);
          }
          (yyval.declSpecs) = ds;
          lCleanUpString((yyvsp[-1].stringVal));
    }
#line 4396 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 153: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 1066 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->baseType != nullptr) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  } else if (CastType<StructType>(ds->baseType)) {
                      // Skip the error if the base type is a struct type to
                      // support typedef struct foo { } foo;
                      ;
                  } else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 4421 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 154: /* declaration_specifiers: type_qualifier  */
#line 1087 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 4429 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 155: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 1091 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 4440 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 156: /* declaration_specifiers: attribute_specifier  */
#line 1098 "src/parse.yy"
      {
          AttributeList *al = (yyvsp[0].attributeList);
          DeclSpecs *ds = new DeclSpecs();
          if (al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 4454 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 157: /* declaration_specifiers: attribute_specifier declaration_specifiers  */
#line 1108 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          AttributeList *al = (yyvsp[-1].attributeList);
          if (ds && al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 4468 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 158: /* attribute_specifier: TOKEN_ATTRIBUTE '(' '(' attribute_list ')' ')'  */
#line 1121 "src/parse.yy"
      {
          (yyval.attributeList) = (yyvsp[-2].attributeList);
      }
#line 4476 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 159: /* attribute_list: attribute  */
#line 1128 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = new AttributeList;
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 4488 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 160: /* attribute_list: attribute_list ',' attribute  */
#line 1136 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = (yyvsp[-2].attributeList);
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 4500 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 161: /* attribute: TOKEN_IDENTIFIER  */
#line 1147 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attr) = new Attribute(*str);
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 4511 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 162: /* attribute: TOKEN_IDENTIFIER '(' attribute_argument ')'  */
#line 1154 "src/parse.yy"
      {
          std::string *str = (yyvsp[-3].stringVal);;
          AttrArgument *arg = (yyvsp[-1].attrArg);
          (yyval.attr) = new Attribute(*str, *arg);
          delete arg;
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 4524 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 163: /* attribute_argument: int_constant  */
#line 1166 "src/parse.yy"
      {
          (yyval.attrArg) = new AttrArgument((yyvsp[0].intVal));
      }
#line 4532 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 164: /* attribute_argument: string_constant  */
#line 1170 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attrArg) = new AttrArgument(*str);
          // deallocate std::string of string_constant
          lCleanUpString(str);
      }
#line 4543 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 165: /* init_declarator_list: init_declarator  */
#line 1180 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4554 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 166: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 1187 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 4569 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 168: /* init_declarator: declarator '=' initializer  */
#line 1202 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 4579 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 169: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 1210 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 4585 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 170: /* storage_class_specifier: TOKEN_EXTERN  */
#line 1211 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 4591 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 171: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 1212 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 4597 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 172: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_SYCL_LITERAL  */
#line 1213 "src/parse.yy"
                                              { (yyval.storageClass) = SC_EXTERN_SYCL; }
#line 4603 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 173: /* storage_class_specifier: TOKEN_STATIC  */
#line 1214 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 4609 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 174: /* type_specifier: atomic_var_type_specifier  */
#line 1218 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 4615 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 175: /* type_specifier: TOKEN_TYPE_NAME  */
#line 1220 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4625 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 176: /* type_specifier: struct_or_union_specifier  */
#line 1225 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 4631 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 177: /* type_specifier: enum_specifier  */
#line 1226 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 4637 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 178: /* type_specifier_list: type_specifier  */
#line 1231 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.typeList) = nullptr;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 4652 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 179: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 1242 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == nullptr)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 4664 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 180: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 1252 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 4670 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 181: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 1253 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 4676 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 182: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 1254 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 4682 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 183: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 1255 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 4688 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 184: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 1256 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 4694 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 185: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 1257 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 4700 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 186: /* atomic_var_type_specifier: TOKEN_INT  */
#line 1258 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 4706 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 187: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 1259 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 4712 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 188: /* atomic_var_type_specifier: TOKEN_FLOAT16  */
#line 1260 "src/parse.yy"
                    { (yyval.atomicType) = AtomicType::UniformFloat16->GetAsUnboundVariabilityType(); }
#line 4718 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 189: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 1261 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 4724 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 190: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 1262 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 4730 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 191: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 1263 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 4736 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 192: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 1264 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 4742 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 193: /* short_vec_specifier: type_specifier '<' int_constant '>'  */
#line 1269 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].type) ? new VectorType((yyvsp[-3].type), (int32_t)(yyvsp[-1].intVal)) : nullptr;
    }
#line 4750 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 194: /* short_vec_specifier: type_specifier '<' TOKEN_IDENTIFIER '>'  */
#line 1273 "src/parse.yy"
    {
        Symbol* s = new Symbol(*(yyvsp[-1].stringVal), Union((yylsp[-3]), (yylsp[-1])), Symbol::SymbolKind::TemplateNonTypeParm, AtomicType::UniformInt32->GetAsConstType());
        lCleanUpString((yyvsp[-1].stringVal));
        (yyval.type) = (yyvsp[-3].type) ? new VectorType((yyvsp[-3].type), s) : nullptr;
    }
#line 4760 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 195: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 1282 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4769 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 196: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 1287 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4778 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 197: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 1295 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == nullptr) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == nullptr &&
                  CastType<UndefinedStructType>(st) == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = nullptr;
              }
              else
                  (yyval.type) = st;
         }
         // allocated by strdup in struct_or_union_name
         free((char*)(yyvsp[0].constCharPtr));
      }
#line 4803 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 199: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1320 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false,
                                              Variability::Unbound, false, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          }
          else
              (yyval.type) = nullptr;
      }
#line 4829 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 200: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1342 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, true, (yylsp[-3]));
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          }
          else
              (yyval.type) = nullptr;
      }
#line 4849 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 201: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1358 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, true, (yylsp[-2]));
      }
#line 4861 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 202: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1366 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, false, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4879 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 204: /* struct_declaration_list: struct_declaration  */
#line 1387 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4890 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 205: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1394 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4905 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 206: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1408 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != nullptr && (yyvsp[-1].structDeclaratorList) != nullptr) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : nullptr; }
#line 4911 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 210: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1416 "src/parse.yy"
    {
        if ((yyvsp[0].type) != nullptr) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_REGCALL) {
                Error((yylsp[-1]), "\"__regcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = nullptr;
        }
    }
#line 4997 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 211: /* struct_declarator_list: struct_declarator  */
#line 1502 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 5008 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 212: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1509 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 5023 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 213: /* struct_declarator: declarator  */
#line 1522 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 5029 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 214: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1531 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup(yytext);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 5038 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 215: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1539 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-1].symbolList), (yylsp[-3]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 5048 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 216: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1545 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-3].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 5061 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 217: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1554 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-2].symbolList), (yylsp[-4]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 5071 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 218: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1560 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-4].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 5084 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 219: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1569 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == nullptr) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = nullptr;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = nullptr;
              }
              else
                  (yyval.enumType) = enumType;
          }
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 5110 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 220: /* enumerator_list: enumerator  */
#line 1594 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == nullptr)
              (yyval.symbolList) = nullptr;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 5124 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 221: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1604 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != nullptr)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 5139 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 222: /* enumerator: enum_identifier  */
#line 1618 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]), Symbol::SymbolKind::Enumerator);
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 5149 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 223: /* enumerator: enum_identifier '=' constant_expression  */
#line 1624 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].constCharPtr) != nullptr && (yyvsp[0].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]), Symbol::SymbolKind::Enumerator);

              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                                  (uint32_t)intValue, (yylsp[0]));
              } else {
                  Error((yylsp[0]), "Enumerator value must be a compile-time constant.");
                  (yyval.symbol) = nullptr;
              }
              (yyval.symbol) = sym;
          }
          else {
              (yyval.symbol) = nullptr;
          }

          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-2].constCharPtr));
      }
#line 5178 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 224: /* type_qualifier: TOKEN_CONST  */
#line 1651 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 5184 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 225: /* type_qualifier: TOKEN_UNIFORM  */
#line 1652 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 5190 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 226: /* type_qualifier: TOKEN_VARYING  */
#line 1653 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 5196 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 227: /* type_qualifier: TOKEN_TASK  */
#line 1654 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 5202 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 228: /* type_qualifier: TOKEN_UNMASKED  */
#line 1655 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 5208 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 229: /* type_qualifier: TOKEN_EXPORT  */
#line 1656 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 5214 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 230: /* type_qualifier: TOKEN_INLINE  */
#line 1657 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 5220 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 231: /* type_qualifier: TOKEN_NOINLINE  */
#line 1658 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 5226 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 232: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1659 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 5232 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 233: /* type_qualifier: TOKEN_REGCALL  */
#line 1660 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_REGCALL; }
#line 5238 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 234: /* type_qualifier: TOKEN_SIGNED  */
#line 1661 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 5244 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 235: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1662 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 5250 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 236: /* type_qualifier_list: type_qualifier  */
#line 1667 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 5258 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 237: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1671 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 5266 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 238: /* declarator: pointer direct_declarator  */
#line 1678 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5282 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 239: /* declarator: reference direct_declarator  */
#line 1690 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5298 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 241: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1705 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 5304 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 242: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1706 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5310 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 243: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1707 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5316 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 244: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1708 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 5322 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 245: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1713 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 5333 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 246: /* direct_declarator: TOKEN_TEMPLATE_NAME  */
#line 1722 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 5344 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 247: /* direct_declarator: '(' declarator ')'  */
#line 1729 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 5352 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 248: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1733 "src/parse.yy"
    {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-3].declarator) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                    d->arraySize = intValue;
                    d->child = (yyvsp[-3].declarator);
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
    }
#line 5387 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 249: /* direct_declarator: direct_declarator '[' ']'  */
#line 1764 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 5402 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 250: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1775 "src/parse.yy"
    {
         (yyval.declarator) = nullptr;
    }
#line 5410 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 251: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1779 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 5429 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 252: /* direct_declarator: direct_declarator '(' ')'  */
#line 1794 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 5443 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 253: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1804 "src/parse.yy"
    {
        (yyval.declarator) = nullptr;
    }
#line 5451 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 254: /* pointer: '*'  */
#line 1812 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 5459 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 255: /* pointer: '*' type_qualifier_list  */
#line 1816 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 5469 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 256: /* pointer: '*' pointer  */
#line 1822 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5479 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 257: /* pointer: '*' type_qualifier_list pointer  */
#line 1828 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 5490 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 258: /* reference: '&'  */
#line 1839 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 5498 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 259: /* parameter_type_list: parameter_list  */
#line 1846 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 5504 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 260: /* parameter_list: parameter_declaration  */
#line 1851 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5515 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 261: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1858 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == nullptr)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 5528 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 262: /* parameter_list: error ','  */
#line 1867 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = nullptr;
    }
#line 5537 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 263: /* parameter_declaration: declaration_specifiers declarator  */
#line 1875 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 5545 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 264: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1879 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != nullptr && (yyvsp[-2].declarator) != nullptr) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = nullptr;
    }
#line 5558 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 265: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1888 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != nullptr && (yyvsp[0].declarator) != nullptr)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = nullptr;
    }
#line 5569 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 266: /* parameter_declaration: declaration_specifiers  */
#line 1895 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == nullptr)
            (yyval.declaration) = nullptr;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 5580 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 268: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1913 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == nullptr || (yyvsp[0].declarator) == nullptr)
            (yyval.type) = nullptr;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), nullptr);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 5593 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 269: /* abstract_declarator: pointer  */
#line 1925 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 5601 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 271: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1930 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5615 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 272: /* abstract_declarator: reference  */
#line 1940 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 5623 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 273: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1944 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5637 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 274: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1957 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5643 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 275: /* direct_abstract_declarator: '[' ']'  */
#line 1959 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 5653 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 276: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1965 "src/parse.yy"
      {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                    d->arraySize = intValue;
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
      }
#line 5686 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 277: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1994 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5701 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 278: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 2005 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> size;
          if ((yyvsp[-3].declarator) != nullptr && (yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              // Check if size holds an int
              if (std::holds_alternative<int>(size)) {
                  int intValue = std::get<int>(size);
                  if (intValue < 0) {
                      Error((yylsp[-1]), "Array dimension must be non-negative.");
                      (yyval.declarator) = nullptr;
                  } else {
                      Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                      d->arraySize = intValue;
                      d->child = (yyvsp[-3].declarator);
                      (yyval.declarator) = d;
                  }
              } else if (std::holds_alternative<Symbol*>(size)) {
                  // Handle the case where size holds a Symbol*
                  Symbol* symbolValuePtr = std::get<Symbol*>(size);
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = symbolValuePtr;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              } else {
                  (yyval.declarator) = nullptr;  
              }
          }
          else {
              (yyval.declarator) = nullptr;
          }
      }
#line 5736 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 279: /* direct_abstract_declarator: '(' ')'  */
#line 2036 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 5742 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 280: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 2038 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-1].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-1].declarationList);
          }
          (yyval.declarator) = d;
      }
#line 5756 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 281: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 2048 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 5770 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 282: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 2058 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
      }
#line 5789 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 284: /* initializer: '{' initializer_list '}'  */
#line 2076 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 5795 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 285: /* initializer: '{' initializer_list ',' '}'  */
#line 2077 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 5801 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 286: /* initializer_list: initializer  */
#line 2082 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 5807 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 287: /* initializer_list: initializer_list ',' initializer  */
#line 2084 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 5822 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 288: /* pragma: TOKEN_PRAGMA  */
#line 2098 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 5830 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 289: /* attributed_statement: pragma attributed_statement  */
#line 2105 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != nullptr)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
        // deallocate yylval.pragmaAttributes returned from pragma and allocated in lPragmaUnroll
        delete (yyvsp[-1].pragmaAttributes);
    }
#line 5844 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 303: /* statement: error ';'  */
#line 2131 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = nullptr;
    }
#line 5853 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 304: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 2139 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
        // allocated by strdup in goto_identifier
        free((char*)(yyvsp[-2].constCharPtr));
    }
#line 5863 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 305: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 2145 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  (yyval.stmt) = new CaseStmt(intValue, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
              } else {
                  Error((yylsp[-2]), "Case statement value must be a compile-time constant or template non-type parameter.");
                  (yyval.stmt) = nullptr;
              }
          }
          else {
              (yyval.stmt) = nullptr;
          }
      }
#line 5885 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 306: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 2163 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 5891 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 307: /* start_scope: '{'  */
#line 2167 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 5897 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 308: /* end_scope: '}'  */
#line 2171 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 5903 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 309: /* compound_statement: '{' '}'  */
#line 2175 "src/parse.yy"
              { (yyval.stmt) = nullptr; }
#line 5909 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 310: /* compound_statement: start_scope statement_list end_scope  */
#line 2176 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 5915 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 311: /* statement_list: attributed_statement  */
#line 2181 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5925 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 312: /* statement_list: statement_list attributed_statement  */
#line 2187 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5939 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 313: /* expression_statement: ';'  */
#line 2199 "src/parse.yy"
          { (yyval.stmt) = nullptr; }
#line 5945 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 314: /* expression_statement: expression ';'  */
#line 2200 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : nullptr; }
#line 5951 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 315: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 2205 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, false, (yylsp[-4])); }
#line 5957 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 316: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2207 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 5963 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 317: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 2209 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, true, (yylsp[-4])); }
#line 5969 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 318: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2211 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5975 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 319: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 2213 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5981 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 320: /* for_test: ';'  */
#line 2218 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 5987 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 321: /* for_test: expression ';'  */
#line 2220 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5993 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 324: /* for_scope: TOKEN_FOR  */
#line 2229 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5999 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 325: /* cfor_scope: TOKEN_CFOR  */
#line 2233 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 6005 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 326: /* foreach_scope: TOKEN_FOREACH  */
#line 2237 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 6011 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 327: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 2241 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 6017 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 328: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 2246 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::VaryingInt32->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6026 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 329: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 2253 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 6032 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 330: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 2258 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::UniformInt64->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6041 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 331: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 2265 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 6050 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 332: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 2269 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 6059 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 333: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 2273 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 6068 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 334: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 2277 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 6077 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 335: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 2285 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 6085 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 336: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 2289 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 6093 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 337: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 2296 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 6102 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 338: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 2301 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == nullptr) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != nullptr)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 6117 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 339: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 2314 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 6123 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 340: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 2319 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6132 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 341: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 2327 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 6138 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 342: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 2329 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 6144 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 343: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2331 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 6150 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 344: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2333 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 6156 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 345: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2335 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 6164 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 346: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2339 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 6172 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 347: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2343 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 6180 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 348: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2347 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 6188 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 349: /* $@1: %empty  */
#line 2351 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 6202 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 350: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 2361 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 6231 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 351: /* $@2: %empty  */
#line 2386 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 6246 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 352: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 2397 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 6275 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 353: /* $@3: %empty  */
#line 2422 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != nullptr)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 6284 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 354: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 2427 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 6293 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 355: /* $@4: %empty  */
#line 2433 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != nullptr &&
             (expr = TypeCheck(expr)) != nullptr &&
             (type = expr->GetType()) != nullptr) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), Symbol::SymbolKind::Variable, iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 6309 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 356: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2445 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();

         // allocated by strdup in foreach_unique_identifier
         free((char*)(yyvsp[-5].constCharPtr));
     }
#line 6321 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 357: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2456 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6330 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 358: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2464 "src/parse.yy"
      {
          (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1]));
          // allocated by strdup in goto_identifier
          free((char*)(yyvsp[-1].constCharPtr));
      }
#line 6340 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 359: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2470 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 6346 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 360: /* jump_statement: TOKEN_BREAK ';'  */
#line 2472 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 6352 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 361: /* jump_statement: TOKEN_RETURN ';'  */
#line 2474 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(nullptr, (yylsp[-1])); }
#line 6358 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 362: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2476 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 6364 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 363: /* sync_statement: TOKEN_SYNC ';'  */
#line 2481 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 6370 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 364: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2486 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 6378 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 365: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2493 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 6386 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 366: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2500 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), nullptr, (yylsp[-4]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-2].stringVal));
      }
#line 6396 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 367: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2506 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-4].stringVal));
      }
#line 6406 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 368: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2515 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
          // deallocate std::string of string_constant
          lCleanUpString((yyvsp[-4].stringVal));
      }
#line 6416 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 378: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2536 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != nullptr)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 6425 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 379: /* external_declaration: declaration  */
#line 2541 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != nullptr)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 6435 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 381: /* $@5: %empty  */
#line 2551 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        m->symbolTable->PushScope();
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 6448 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 382: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2560 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            // FIXME: Next list is redundant, as it's done in lAddDeclaration()
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == nullptr)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 6470 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 383: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER  */
#line 2589 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[0].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-1]), (yylsp[0])));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6479 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 384: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER '=' type_specifier  */
#line 2594 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[-2].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-3]), (yylsp[-2])));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template type parameters are not yet supported.");
      }
#line 6490 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 385: /* int_constant_type: TOKEN_INT8  */
#line 2603 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformInt8->GetAsConstType(); }
#line 6496 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 386: /* int_constant_type: TOKEN_INT16  */
#line 2604 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformInt16->GetAsConstType(); }
#line 6502 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 387: /* int_constant_type: TOKEN_INT  */
#line 2605 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformInt32->GetAsConstType(); }
#line 6508 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 388: /* int_constant_type: TOKEN_INT64  */
#line 2606 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformInt64->GetAsConstType(); }
#line 6514 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 389: /* int_constant_type: TOKEN_UINT8  */
#line 2607 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsConstType(); }
#line 6520 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 390: /* int_constant_type: TOKEN_UINT16  */
#line 2608 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsConstType(); }
#line 6526 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 391: /* int_constant_type: TOKEN_UINT  */
#line 2609 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsConstType(); }
#line 6532 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 392: /* int_constant_type: TOKEN_UINT64  */
#line 2610 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsConstType(); }
#line 6538 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 393: /* int_constant_type: TOKEN_BOOL  */
#line 2611 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformBool->GetAsConstType(); }
#line 6544 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 394: /* template_int_constant_type: TOKEN_UNIFORM int_constant_type  */
#line 2615 "src/parse.yy"
                                      { (yyval.atomicType) = (yyvsp[0].atomicType); }
#line 6550 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 395: /* template_int_constant_type: int_constant_type  */
#line 2616 "src/parse.yy"
                        { (yyval.atomicType) = (yyvsp[0].atomicType);}
#line 6556 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 396: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER  */
#line 2621 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-1].atomicType));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6565 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 397: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER '=' int_constant  */
#line 2626 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[-2].stringVal), Union((yylsp[-3]), (yylsp[-2])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-3].atomicType));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template non-type parameters are not yet supported.");
      }
#line 6576 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 398: /* template_enum_parameter: TOKEN_TYPE_NAME TOKEN_IDENTIFIER  */
#line 2636 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[-1].stringVal)->c_str());
          const EnumType *enumType = CastType<EnumType>(type);
          if (enumType == nullptr) {
            Error((yylsp[-1]), "Only enum types and integral types are allowed as non-type template parameters.");
          }
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, enumType->GetAsConstType()->GetAsUniformType());
          lCleanUpString((yyvsp[-1].stringVal));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6591 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 399: /* template_parameter: template_type_parameter  */
#line 2649 "src/parse.yy"
    {
        if ((yyvsp[0].templateTypeParm) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].templateTypeParm));
        }
    }
#line 6601 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 400: /* template_parameter: template_int_parameter  */
#line 2655 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 6611 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 401: /* template_parameter: template_enum_parameter  */
#line 2661 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 6621 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 402: /* template_parameter_list: template_parameter  */
#line 2670 "src/parse.yy"
      {
          TemplateParms *list = new TemplateParms();
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6633 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 403: /* template_parameter_list: template_parameter_list ',' template_parameter  */
#line 2678 "src/parse.yy"
      {
          TemplateParms *list = (TemplateParms *) (yyvsp[-2].templateParmList);
          if (list == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              list = new TemplateParms();
          }
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 6649 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 404: /* template_head: TOKEN_TEMPLATE '<' template_parameter_list '>'  */
#line 2693 "src/parse.yy"
      {
          (yyval.templateParmList) = (yyvsp[-1].templateParmList);
      }
#line 6657 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 405: /* $@6: %empty  */
#line 2700 "src/parse.yy"
      {
          // Scope for template parameters definition
          m->symbolTable->PushScope();
          TemplateParms *list = (TemplateParms *) (yyvsp[0].templateParmList);
          for(size_t i = 0; i < list->GetCount(); i++) {
              std::string name = (*list)[i]->GetName();
              SourcePos pos = (*list)[i]->GetSourcePos();
              if ((*list)[i]->IsTypeParam()) {
                  m->AddTypeDef(name, (*list)[i]->GetTypeParam(), pos);
              } else if ((*list)[i]->IsNonTypeParam()) {
                  m->symbolTable->AddVariable((*list)[i]->GetNonTypeParam());
              }
          }
      }
#line 6676 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 406: /* template_declaration: template_head $@6 declaration_specifiers declarator  */
#line 2715 "src/parse.yy"
      {
          lAddTemplateDeclaration((yyvsp[-3].templateParmList), (yyvsp[-1].declSpecs), (yyvsp[0].declarator));
          lAddFunctionParams((yyvsp[0].declarator));
          lAddMaskToSymbolTable((yylsp[0]));
          const FunctionType *ft = CastType<FunctionType>((yyvsp[0].declarator)->type);
          // Creating a new TemplateSymbol just to pass it further seems to be a waste
          (yyval.functionTemplateSym) = new TemplateSymbol((yyvsp[-3].templateParmList), (yyvsp[0].declarator)->name, ft, (yyvsp[-1].declSpecs)->storageClass, (yylsp[0]), false /*not used*/, false /*not used*/);
      }
#line 6689 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 407: /* template_function_declaration_or_definition: template_declaration ';'  */
#line 2727 "src/parse.yy"
      {
          // deallocate TemplateSymbol created in template_declaration
          delete (yyvsp[-1].functionTemplateSym);
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6700 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 408: /* template_function_declaration_or_definition: template_declaration compound_statement  */
#line 2734 "src/parse.yy"
      {
          if ((yyvsp[-1].functionTemplateSym) != nullptr) {
              Stmt *code = (yyvsp[0].stmt);
              if (code == nullptr) code = new StmtList((yylsp[0]));
              m->AddFunctionTemplateDefinition((yyvsp[-1].functionTemplateSym)->templateParms, (yyvsp[-1].functionTemplateSym)->name, (yyvsp[-1].functionTemplateSym)->type, code);
              // deallocate TemplateSymbol created in template_declaration
              delete (yyvsp[-1].functionTemplateSym);
          }

          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 6717 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 409: /* template_argument: rate_qualified_type_specifier  */
#line 2750 "src/parse.yy"
    {
        (yyval.templateArg) = new TemplateArg((yyvsp[0].type), (yylsp[0]));
    }
#line 6725 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 410: /* template_argument: TOKEN_INT8_CONSTANT  */
#line 2756 "src/parse.yy"
                          {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6734 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 411: /* template_argument: TOKEN_UINT8_CONSTANT  */
#line 2760 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6743 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 412: /* template_argument: TOKEN_INT16_CONSTANT  */
#line 2764 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6752 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 413: /* template_argument: TOKEN_UINT16_CONSTANT  */
#line 2768 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6761 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 414: /* template_argument: TOKEN_INT32_CONSTANT  */
#line 2772 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6770 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 415: /* template_argument: TOKEN_UINT32_CONSTANT  */
#line 2776 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6779 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 416: /* template_argument: TOKEN_INT64_CONSTANT  */
#line 2780 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6788 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 417: /* template_argument: TOKEN_UINT64_CONSTANT  */
#line 2784 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 6797 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 418: /* template_argument: TOKEN_TRUE  */
#line 2788 "src/parse.yy"
                 {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0])), (yylsp[0]));
    }
#line 6805 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 419: /* template_argument: TOKEN_FALSE  */
#line 2791 "src/parse.yy"
                  {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0])), (yylsp[0]));
    }
#line 6813 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 420: /* template_argument: TOKEN_IDENTIFIER  */
#line 2796 "src/parse.yy"
    {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        if (s) {
            if (s->GetSymbolKind() == Symbol::SymbolKind::Enumerator ||
                s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
                (yyval.templateArg) = new TemplateArg(new SymbolExpr(s, (yylsp[0])), (yylsp[0]));
            } else {
                Error((yylsp[0]), "Only integral, enum types and non-type template parameters are allowed as template arguments.");
                (yyval.templateArg) = nullptr;
            }
        } else {
            Error((yylsp[0]), "Unknown identifier");
            (yyval.templateArg) = nullptr;
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6835 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 421: /* template_argument_list: template_argument  */
#line 2817 "src/parse.yy"
      {
          TemplateArgs *templArgs = new TemplateArgs();
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;

      }
#line 6848 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 422: /* template_argument_list: template_argument_list ',' template_argument  */
#line 2826 "src/parse.yy"
      {
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-2].templateArgs);
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;
      }
#line 6860 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 423: /* template_identifier: TOKEN_TEMPLATE_NAME  */
#line 2837 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 6869 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 424: /* simple_template_id: template_identifier '<' template_argument_list '>'  */
#line 2845 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[-3]));
          d->name = (yyvsp[-3].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[-3].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-1].templateArgs);
          // Bundle template ID declarator and type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6885 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 425: /* simple_template_id: template_identifier  */
#line 2857 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = (yyvsp[0].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[0].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = new TemplateArgs();
          // Bundle template ID declarator and empty type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6901 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 426: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' parameter_type_list ')' ';'  */
#line 2874 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-4].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-1])));
          d->child = simpleTemplID->first;
          if ((yyvsp[-2].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-2].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-2].declarationList);
          }

          d->InitFromDeclSpecs((yyvsp[-5].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-5].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-4].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-4].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-4].simpleTemplateID)->first->name, *(yyvsp[-4].simpleTemplateID)->second, ftype, (yyvsp[-5].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-6]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 6931 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 427: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' ')' ';'  */
#line 2900 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-3].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-5]), (yylsp[-1])));
          d->child = simpleTemplID->first;

          d->InitFromDeclSpecs((yyvsp[-4].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-4].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-3].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-3].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-3].simpleTemplateID)->first->name, *(yyvsp[-3].simpleTemplateID)->second, ftype, (yyvsp[-4].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-5]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 6956 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 428: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' error ')' ';'  */
#line 2921 "src/parse.yy"
      {
          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-4].simpleTemplateID));
      }
#line 6965 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 429: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' parameter_type_list ')'  */
#line 2931 "src/parse.yy"
      {
        // Function declarator
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-7]), (yylsp[0])));
        d->child = (yyvsp[-3].simpleTemplateID)->first;

        if ((yyvsp[-1].declarationList) != nullptr) {
            d->functionParams = *(yyvsp[-1].declarationList);
            // parameter_type_list returns vector of Declarations that is not needed anymore.
            delete (yyvsp[-1].declarationList);
        }
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-3].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-4].declSpecs), d);
        m->symbolTable->PushScope();

        lAddFunctionParams(d);
        lAddMaskToSymbolTable((yylsp[-3]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 6991 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 430: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' ')'  */
#line 2953 "src/parse.yy"
      {
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-2])));
        d->child = (yyvsp[-2].simpleTemplateID)->first;
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-2].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-3].declSpecs), d);
        m->symbolTable->PushScope();

        lAddMaskToSymbolTable((yylsp[-2]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 7009 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 431: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' error ')'  */
#line 2967 "src/parse.yy"
      {
        m->symbolTable->PushScope();
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = nullptr;
      }
#line 7020 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 432: /* template_function_specialization: template_function_specialization_declaration ';'  */
#line 2977 "src/parse.yy"
      {
          if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            // deallocate TemplateSymbol created in template_declaration
            lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
          }
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 7033 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;

  case 433: /* template_function_specialization: template_function_specialization_declaration compound_statement  */
#line 2986 "src/parse.yy"
      {
        if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            Declarator *d = (yyvsp[-1].simpleTemplateID)->first;
            const FunctionType *ftype = CastType<FunctionType>(d->type);
            if (ftype == nullptr)
                AssertPos((yylsp[-1]), m->errorCount > 0);
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionTemplateSpecializationDefinition(d->name, ftype, *(yyvsp[-1].simpleTemplateID)->second, Union((yylsp[-1]), (yylsp[0])), code);
            }
           lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
        }
        m->symbolTable->PopScope();
      }
#line 7053 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"
    break;


#line 7057 "/home/iurt/rpmbuild/BUILD/ispc-1.26.0-build/ispc-1.26.0/build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3003 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}

void lCleanUpString(std::string *s) {
    if (s) {
         delete s;
    }
}

void lFreeSimpleTemplateID(void *p) {
    SimpleTemplateIDType *sid = (SimpleTemplateIDType*) p;
    TemplateArgs *templArgs = sid->second;
    if (templArgs) {
        delete templArgs;
    }
    if (sid) {
        delete sid;
    }
}

static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == nullptr)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF) {
        const StructType *st = CastType<StructType>(decl->type);
        if (st && st->IsAnonymousType()) {
            st = st->GetAsNamed(decl->name);
            m->AddTypeDef(decl->name, st, decl->pos);
        } else {
            m->AddTypeDef(decl->name, decl->type, decl->pos);
        }
    } else {
        if (decl->type == nullptr) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != nullptr) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
            Declarator *funcDecl = decl;

            // In a case when function return type is a pointer we have decl
            // with DK_POINTER kind. We need to traverse childs to get
            // DK_FUNCTION declarator.
            while (funcDecl && funcDecl->kind != DK_FUNCTION) {
                funcDecl = funcDecl->child;
            }
            Assert(funcDecl);

            // For pointer return type we have attributeList attached to decl
            // (DK_POINTER) whereas we need to pass DK_FUNCTION declarator to
            // AddFunctionDeclaration. Create a copy of DK_FUNCTION and attach
            // attributeList from DK_POINTER.
            Declarator funcDeclCopy = *funcDecl;
            if (decl->attributeList) {
                funcDeclCopy.attributeList = new AttributeList(*decl->attributeList);
            }

            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass, &funcDeclCopy,
                                      isInline, isNoInline, isVectorCall, isRegCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl, isConst);
        }
    }
}

static void
lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name) {
    std::string templateTypeStr;
    switch (type) {
        case TemplateType::Template:
            templateTypeStr = "function template";
            break;
        case TemplateType::Instantiation:
            templateTypeStr = "template instantiation";
            break;
        case TemplateType::Specialization:
            templateTypeStr = "template specialization";
            break;
        default:
            FATAL("Unhandled template type in lCheckTemplateDeclSpecs");
    }
    if (ds->typeQualifiers & TYPEQUAL_TASK){
        Error(pos, "'task' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->typeQualifiers & TYPEQUAL_EXPORT) {
        Error(pos, "'export' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->storageClass == SC_TYPEDEF) {
        Error(pos, "Illegal \"typedef\" provided with %s.", templateTypeStr.c_str());
        return;
    }
    // We can't support extern "C"/extern "SYCL" for templates because
    // we need mangling information.
    if (ds->storageClass == SC_EXTERN_C || ds->storageClass == SC_EXTERN_SYCL) {
        Error(pos, "Illegal linkage provided with %s.", templateTypeStr.c_str());
        return;
    }
    Assert(ds->storageClass == SC_NONE || ds->storageClass == SC_STATIC || ds->storageClass == SC_EXTERN);
    bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
    if (isVectorCall) {
        Error(pos, "Illegal to use \"__vectorcall\" qualifier on non-extern function \"%s\".", name);
    }
    bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
    if (isRegCall) {
        Error(pos, "Illegal to use \"__regcall\" qualifier on non-extern function \"%s\".", name);
    }
}

static void
lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr) {
        // Error happened earlier during parsing
        return;
    }

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Template, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    const FunctionType *ft = CastType<FunctionType>(decl->type);
    if (ft != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateDeclaration(templateParmList, decl->name, ft, ds->storageClass,
                                          isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function templates are supported.");
    }

}

static void
lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Specialization, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    if (templArgs.size() == 0) {
        Error(decl->pos, "Template arguments deduction is not yet supported in template function specialization.");
        return;
    }

    const FunctionType *ftype = CastType<FunctionType>(decl->type);
    if (ftype != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateSpecializationDeclaration(decl->name, ftype, templArgs, ds->storageClass,
                                                        isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function template specializations are supported.");
    }
}

/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    // It's responsibility of the caller to create a new symbol table scope.
    // For regular functions, the scope starts before function parameters.
    // For template functions, the scope starts before template parameters.
    if (decl == nullptr) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != nullptr)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != nullptr && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == nullptr)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos, Symbol::SymbolKind::FunctionParm,
                                     declarator->type, declarator->storageClass);

            AttributeList *AL = declarator->attributeList;
            if (AL) {
                // Check for unknown attributes for parameters in function definitions.
                AL->CheckForUnknownAttributes(declarator->pos);
            }
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = nullptr;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, Symbol::SymbolKind::Default, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym);

    Symbol *taskCountSym = new Symbol("taskCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym);

    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym2);


    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    case SC_EXTERN_SYCL:
        return "extern \"SYCL\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage) {
    if (expr == nullptr)
        return false;
    expr = TypeCheck(expr);
    if (expr == nullptr)
        return false;
    expr = Optimize(expr);
    if (expr == nullptr)
        return false;
    const SymbolExpr* se= llvm::dyn_cast<SymbolExpr>(expr);
    if (se) {
        Symbol* s = se->GetBaseSymbol();
        if (s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
            value->emplace<Symbol*>(s);
            return true;
        }
    }
    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == nullptr) {
        Error(pos, "%s must be a compile-time constant or template non-type parameter.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == nullptr) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        int resultValue = type->IsUnsignedType() ? (int)ci->getZExtValue() : (int)ci->getSExtValue();
        value->emplace<int>(resultValue);
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == nullptr)
        return nullptr;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != nullptr)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != nullptr) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != nullptr);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
